spool 03_tablas.log

-- Creacin de la tabla COMUNIDAD_AUTONOMA
prompt Creando la tabla Comunidad Autonoma ......
CREATE TABLE COMUNIDAD_AUTONOMA(
  ID_AUTONOMIA		NUMBER(2) NOT NULL,
  DESCRIPCION		VARCHAR2(30 BYTE) NOT NULL,
  
  CONSTRAINT PK_AUTONOMIA PRIMARY KEY (ID_AUTONOMIA), 
  CONSTRAINT UN_AUTONOMIA UNIQUE (DESCRIPCION)   
)  
TABLESPACE TFG_Datos
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

-- Creacin de la tabla PROVINCIA
prompt Creando la tabla Provincia ......
CREATE TABLE PROVINCIA(
  ID_PROVINCIA		NUMBER(2) NOT NULL,
  DESCRIPCION		VARCHAR2(25 BYTE) NOT NULL,
  ID_AUTONOMIA		NUMBER(2) NOT NULL,
  
  CONSTRAINT PK_PROVINCIA PRIMARY KEY (ID_PROVINCIA), 
  CONSTRAINT UN_PROVINCIA UNIQUE (DESCRIPCION), 

  CONSTRAINT PROVINCIA_AUTON_FK
    FOREIGN KEY (ID_AUTONOMIA)
    REFERENCES COMUNIDAD_AUTONOMA (ID_AUTONOMIA)
)  
TABLESPACE TFG_Datos
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

-- Creacin de la tabla MUNICIPIO
prompt Creando la tabla Municipio ......
CREATE TABLE MUNICIPIO(
  ID_MUNICIPIO		NUMBER(4) NOT NULL,
  DESCRIPCION		VARCHAR2(50 BYTE) NOT NULL,
  ID_PROVINCIA		NUMBER(2) NOT NULL,
  
  CONSTRAINT PK_MUNICIPIO PRIMARY KEY (ID_MUNICIPIO),
  CONSTRAINT UN_MUNICIPIO UNIQUE (ID_PROVINCIA, DESCRIPCION),

  CONSTRAINT MUNICIPIO_PROV_FK
    FOREIGN KEY (ID_PROVINCIA)
    REFERENCES PROVINCIA (ID_PROVINCIA)
)  
TABLESPACE TFG_Datos
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

-- Creacin de la tabla TITULACION
prompt Creando la tabla Titulacion ......
CREATE TABLE TITULACION(
  ID_TITULACION		NUMBER(2) NOT NULL,
  DESCRIPCION		VARCHAR2(100 BYTE) NOT NULL,
  
  CONSTRAINT PK_TITULACION PRIMARY KEY (ID_TITULACION),
  CONSTRAINT UN_TITULACION UNIQUE (DESCRIPCION) 
)  
TABLESPACE TFG_Datos
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

--- Creacin de la tabla PARAMETROS
prompt Creando la tabla Parametros.....
CREATE TABLE PARAMETROS(
  ID_PARAMETRO		VARCHAR2(20 BYTE) NOT NULL,
  TIPO				VARCHAR2(10 BYTE) NOT NULL,
  CAMPO				VARCHAR2(20 BYTE) NOT NULL,
  VALOR				VARCHAR2(100 BYTE) NOT NULL,

  CONSTRAINT PK_PARAMETROS PRIMARY KEY (ID_PARAMETRO),
  CONSTRAINT PARAMETROS_CHK1 CHECK (UPPER(TIPO) IN ('PARTIDO','CENSO','MESA', 'ESCRUTINIO'))
)
TABLESPACE TFG_Datos
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

-- Creacin de la tabla PARTIDO_POLITICO
prompt Creando la tabla Partido Politico ......
CREATE TABLE PARTIDO_POLITICO(
  ID_PARTIDO		NUMBER(3) NOT NULL,
  SIGLAS			VARCHAR2(10 BYTE) NOT NULL,
  NOMBRE			VARCHAR2(100 BYTE) NOT NULL,
  DIRECCION			VARCHAR2(100 BYTE) NOT NULL,
  FECHA_INSCRIPCION	DATE NOT NULL,
  
  CONSTRAINT PK_PARTIDO PRIMARY KEY (ID_PARTIDO),
  CONSTRAINT UN1_PARTIDO UNIQUE (SIGLAS),
  CONSTRAINT UN2_PARTIDO UNIQUE (NOMBRE)
)  
TABLESPACE TFG_Datos
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

-- Creacin de la tabla USUARIOS
prompt Creando la tabla Usuarios ......
CREATE TABLE USUARIOS(
  ID_USUARIO		VARCHAR2(20 BYTE) NOT NULL,
  CLAVE				VARCHAR2(15 BYTE) NOT NULL,
  NIVEL				VARCHAR2(8 BYTE) NOT NULL,
  ESTADO			VARCHAR2(13) NOT NULL,
  
  CONSTRAINT PK_USUARIOS PRIMARY KEY (ID_USUARIO),
  CONSTRAINT USUARIOS_CHK1 CHECK (UPPER(NIVEL) IN ('NORMAL','AVANZADO')),
  CONSTRAINT USUARIOS_CHK2 CHECK (UPPER(ESTADO) IN ('HABILITADO','DESHABILITADO'))
)  
TABLESPACE TFG_Datos
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

-- Creacin de la tabla LOG_PROCESOS
prompt Creando la tabla Log_Procesos ......
CREATE TABLE LOG_PROCESOS(
  ID_LOG				NUMBER(15) NOT NULL,
  FECHA					DATE NOT NULL,
  PROCEDIMIENTO			VARCHAR2(100 BYTE) NOT NULL,
  PARAMETROS_ENTRADA	VARCHAR2(700 BYTE) NOT NULL,
  PARAMETROS_SALIDA		VARCHAR2(200 BYTE) NOT NULL,
  
  CONSTRAINT PK_LOG_PROCESOS PRIMARY KEY (ID_LOG) 
)  
TABLESPACE TFG_Datos
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

--- Creacin de la tabla CONVOCATORIA
prompt Creando la tabla Convocatoria.....
CREATE TABLE CONVOCATORIA(
  ID_CONVOCATORIA		VARCHAR2(20 BYTE) NOT NULL,
  DESCRIPCION			VARCHAR2(100 BYTE) NOT NULL,
  FECHA_PUBLICACION		DATE NOT NULL,
  FECHA_INICIO			DATE NOT NULL,
  FECHA_FIN				DATE NOT NULL,
  TIPO           		VARCHAR2(10 BYTE) NOT NULL,
  AUTONOMIA	  			NUMBER(2),
  NUMERO_ESCANOS		NUMBER(3) NOT NULL,
  ESTADO				VARCHAR2(10 BYTE) NOT NULL,

  CONSTRAINT PK_CONVOCATORIA PRIMARY KEY (ID_CONVOCATORIA),
  CONSTRAINT CONVOCATORIA_CHK1 CHECK (UPPER(TIPO) IN ('ESTATAL','AUTONOMICA','MUNICIPAL')),
  CONSTRAINT CONVOCATORIA_CHK2 CHECK (UPPER(ESTADO) IN ('ABIERTA','CERRADA','FINALIZADA','ANULADA')),
  CONSTRAINT CONVOCATORIA_CHK3 CHECK (FECHA_PUBLICACION < FECHA_INICIO),
  CONSTRAINT CONVOCATORIA_CHK4 CHECK (FECHA_FIN > FECHA_INICIO),
  CONSTRAINT CONVOCATORIA_CHK5 CHECK (NUMERO_ESCANOS > 0)
)
TABLESPACE TFG_Datos
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

-- Creacin de la tabla CONVOCATORIA_PARAMETROS
prompt Creando la tabla Convocatoria_Parametros ......
CREATE TABLE CONVOCATORIA_PARAMETROS(
  ID_CONVOCATORIA		VARCHAR2(20 BYTE) NOT NULL,
  ID_PARAMETRO			VARCHAR2(20 BYTE) NOT NULL,

  CONSTRAINT PK_CONVOCATORIA_PARAM PRIMARY KEY (ID_CONVOCATORIA,ID_PARAMETRO),

  CONSTRAINT CONVOCATORIA_PARAM_CONV_FK
    FOREIGN KEY (ID_CONVOCATORIA)
    REFERENCES CONVOCATORIA (ID_CONVOCATORIA),

  CONSTRAINT CONVOCATORIA_PARAM_PARAM_FK
    FOREIGN KEY (ID_PARAMETRO)
    REFERENCES PARAMETROS (ID_PARAMETRO)
)
TABLESPACE TFG_Datos
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

-- Creacin de la tabla PADRON_MUNICIPAL
prompt Creando la tabla Padron_Municipal ......
CREATE TABLE PADRON_MUNICIPAL(
  ID_PADRON					VARCHAR2(20 BYTE) NOT NULL,
  NOMBRE					VARCHAR2(100 BYTE) NOT NULL,
  APELLIDO1					VARCHAR2(100 BYTE) NOT NULL,
  APELLIDO2					VARCHAR2(100 BYTE),
  NUM_DOCUMENTO				VARCHAR2(20 BYTE) NOT NULL,
  FECHA_NACIMIENTO			DATE NOT NULL,
  PROVINCIA_NACIMIENTO		VARCHAR2(50 BYTE) NOT NULL,
  MUNICIPIO_NACIMIENTO		VARCHAR2(85 BYTE) NOT NULL,
  PAIS						VARCHAR2(60 BYTE) NOT NULL,
  SEXO						VARCHAR2(6 BYTE) NOT NULL,
  PROVINCIA_DOMICILIO		NUMBER(2) NOT NULL,
  MUNICIPIO_DOMICILIO		NUMBER(3) NOT NULL,
  DIRECCION					VARCHAR2(100 BYTE) NOT NULL,
  TITULACION				NUMBER(2) NOT NULL,

  CONSTRAINT PK_PADRON PRIMARY KEY (ID_PADRON),
  CONSTRAINT UN_PADRON UNIQUE (NUM_DOCUMENTO), 

  CONSTRAINT PADRON_CHK1 CHECK (UPPER(SEXO) IN ('HOMBRE','MUJER')),

  CONSTRAINT PADRON_TITUL_FK
    FOREIGN KEY (TITULACION)
    REFERENCES TITULACION (ID_TITULACION)
)
TABLESPACE TFG_Datos
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

-- Creacin de la tabla DEMARCACION
prompt Creando la tabla Demarcacion ......
CREATE TABLE DEMARCACION(
  ID_DEMARCACION			NUMBER(15) NOT NULL,
  ESCANOS					NUMBER(3) NOT NULL,
  VOTANTES					NUMBER(9) NOT NULL,
  ID_CONVOCATORIA			VARCHAR2(20 BYTE) NOT NULL,

  CONSTRAINT PK_DEMARCACION PRIMARY KEY (ID_DEMARCACION),
  CONSTRAINT DEMARCACION_CHK1 CHECK (ESCANOS > 0),
  CONSTRAINT DEMARCACION_CHK2 CHECK (VOTANTES > 0),

  CONSTRAINT DEMARCACION_CONV_FK
    FOREIGN KEY (ID_CONVOCATORIA)
    REFERENCES CONVOCATORIA (ID_CONVOCATORIA)
)
TABLESPACE TFG_Datos
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

-- Creacin de la tabla RESULTADOS
prompt Creando la tabla Resultados ......
CREATE TABLE RESULTADOS(
  ID_RESULTADO			NUMBER(6) NOT NULL,
  PARTIDO				NUMBER(3) NOT NULL,
  ESCANOS				NUMBER(3) NOT NULL,
  VOTOS					NUMBER(9) NOT NULL,
  PORCENTAJE_VOTOS		NUMBER(5,2) NOT NULL,
  ID_DEMARCACION		NUMBER(15) NOT NULL,

  CONSTRAINT PK_RESULTADOS PRIMARY KEY (ID_RESULTADO),
  CONSTRAINT RESULTADOS_CHK1 CHECK (ESCANOS >= 0),
  CONSTRAINT RESULTADOS_CHK2 CHECK (VOTOS > 0),
  CONSTRAINT RESULTADOS_CHK3 CHECK (PORCENTAJE_VOTOS > 0),

  CONSTRAINT RESULTADOS_DEMAR_FK
    FOREIGN KEY (ID_DEMARCACION)
    REFERENCES DEMARCACION (ID_DEMARCACION)
)
TABLESPACE TFG_Datos
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

-- Creacin de la tabla CENTRO_VOTACION
prompt Creando la tabla Centro Votacion ......
CREATE TABLE CENTRO_VOTACION(
  ID_DEMARCACION		NUMBER(15) NOT NULL,
  ID_MUNICIPIO			NUMBER(4) NOT NULL,
  DISTRITO				NUMBER(3) NOT NULL,
  SECCION				NUMBER(3) NOT NULL,
  DIRECCION				VARCHAR2(100 BYTE) NOT NULL,
  CODIGO_POSTAL			NUMBER(5) NOT NULL,
  SORTEADO				CHAR(1) DEFAULT 'N' NOT NULL,
  NOTIFICADO			CHAR(1) DEFAULT 'N' NOT NULL,

  CONSTRAINT PK_CENTRO_VOTACION PRIMARY KEY (ID_DEMARCACION,ID_MUNICIPIO),
  CONSTRAINT CENTRO_VOTACION_CHK1 CHECK (UPPER(SORTEADO) IN ('S','N')),
  CONSTRAINT CENTRO_VOTACION_CHK2 CHECK (UPPER(NOTIFICADO) IN ('S','N')),

  CONSTRAINT CENTRO_VOTACION_DEMARC_FK
    FOREIGN KEY (ID_DEMARCACION)
    REFERENCES DEMARCACION (ID_DEMARCACION),

  CONSTRAINT CENTRO_VOTACION_MUNIC_FK
    FOREIGN KEY (ID_MUNICIPIO)
    REFERENCES MUNICIPIO (ID_MUNICIPIO)
)
TABLESPACE TFG_Datos
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

-- Creacin de la tabla MESA
prompt Creando la tabla Mesa ......
CREATE TABLE MESA(
  ID_MESA			NUMBER(9) NOT NULL,
  DESCRIPCION		VARCHAR2(100 BYTE) NOT NULL,
  ESTADO			VARCHAR2(10 BYTE) NOT NULL,
  ID_DEMARCACION	NUMBER(15) NOT NULL,
  ID_MUNICIPIO		NUMBER(4) NOT NULL,

  CONSTRAINT PK_MESA PRIMARY KEY (ID_MESA),
  CONSTRAINT MESA_CHK1 CHECK (UPPER(ESTADO) IN ('ABIERTA','CERRADA','FINALIZADA','ANULADA')),

  CONSTRAINT MESA_C_VOTACION_FK
    FOREIGN KEY (ID_DEMARCACION, ID_MUNICIPIO)
    REFERENCES CENTRO_VOTACION (ID_DEMARCACION, ID_MUNICIPIO)
)
TABLESPACE TFG_Datos
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

-- Creacin de la tabla VOTACION
prompt Creando la tabla Votacion ......
CREATE TABLE VOTACION(
  TIPO				VARCHAR2(10 BYTE) NOT NULL,
  CERTIFICADO		VARCHAR2(100 BYTE),
  ID_MESA			NUMBER(9) NOT NULL,

  CONSTRAINT VOTACION_CHK1 CHECK (UPPER(TIPO) IN ('PRESENCIAL','TELEMATICO')),

  CONSTRAINT VOTACION_MESA_FK
    FOREIGN KEY (ID_MESA)
    REFERENCES MESA (ID_MESA)
)
TABLESPACE TFG_Datos
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

-- Creacin de la tabla RECUENTO
prompt Creando la tabla Recuento ......
CREATE TABLE RECUENTO(
  PARTIDO			NUMBER(3) NOT NULL,
  VOTOS				NUMBER(9) NOT NULL,
  ID_MESA			NUMBER(9) NOT NULL,

  CONSTRAINT RECUENTO_CHK1 CHECK (VOTOS >= 0),
  CONSTRAINT UN_RECUENTO UNIQUE (PARTIDO, ID_MESA),

  CONSTRAINT RECUENTO_MESA_FK
    FOREIGN KEY (ID_MESA)
    REFERENCES MESA (ID_MESA)
)
TABLESPACE TFG_Datos
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

-- Creacin de la tabla CENSO_ELECTORAL
prompt Creando la tabla Censo Electoral ......
CREATE TABLE CENSO_ELECTORAL(
  ID_CONVOCATORIA		VARCHAR2(20 BYTE) NOT NULL,
  ID_PADRON				VARCHAR2(20 BYTE) NOT NULL,
  FECHA_INSCRIPCION		DATE NOT NULL,
  ES_MESA				CHAR(1) DEFAULT 'N' NOT NULL,
  TIPO					VARCHAR2(8 BYTE),
  NOTIFICADO			CHAR(1),
  ALEGA					CHAR(1),
  PRESENTADO			CHAR(1),
  ID_MESA				NUMBER(9) NOT NULL,

  CONSTRAINT PK_CENSO_ELECTORAL PRIMARY KEY (ID_CONVOCATORIA,ID_PADRON),
  CONSTRAINT CENSO_ELECTORAL_CHK1 CHECK (UPPER(TIPO) IN ('TITULAR','SUPLENTE')),
  CONSTRAINT CENSO_ELECTORAL_CHK2 CHECK (UPPER(ES_MESA) IN ('S','N')),
  CONSTRAINT CENSO_ELECTORAL_CHK3 CHECK (UPPER(NOTIFICADO) IN ('S','N')),
  CONSTRAINT CENSO_ELECTORAL_CHK4 CHECK (UPPER(ALEGA) IN ('S','N')),
  CONSTRAINT CENSO_ELECTORAL_CHK5 CHECK (UPPER(PRESENTADO) IN ('S','N')),

  CONSTRAINT CENSO_ELECTORAL_CONVOC_FK
    FOREIGN KEY (ID_CONVOCATORIA)
    REFERENCES CONVOCATORIA (ID_CONVOCATORIA),

  CONSTRAINT CENSO_ELECTORAL_PADRON_FK
    FOREIGN KEY (ID_PADRON)
    REFERENCES PADRON_MUNICIPAL (ID_PADRON),

  CONSTRAINT CENSO_ELECTORAL_MESA_FK
    FOREIGN KEY (ID_MESA)
    REFERENCES MESA (ID_MESA)
)
TABLESPACE TFG_Datos
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

-- Creacin de la tabla CANDIDATURA
prompt Creando la tabla Candidatura ......
CREATE TABLE CANDIDATURA(
  ID_DEMARCACION		NUMBER(15) NOT NULL,
  ID_PARTIDO			NUMBER(3) NOT NULL,
  ESTADO				VARCHAR2(10 BYTE) NOT NULL,

  CONSTRAINT PK_CANDIDATURA PRIMARY KEY (ID_DEMARCACION, ID_PARTIDO),
  CONSTRAINT CANDIDATURA_CHK1 CHECK (UPPER(ESTADO) IN ('PRESENTADA','APROBADA','RECHAZADA', 'ANULADA')),

  CONSTRAINT CANDIDATURA_DEMARC_FK
    FOREIGN KEY (ID_DEMARCACION)
    REFERENCES DEMARCACION (ID_DEMARCACION),

  CONSTRAINT CANDIDATURA_PARTIDO_FK
    FOREIGN KEY (ID_PARTIDO)
    REFERENCES PARTIDO_POLITICO (ID_PARTIDO)
)
TABLESPACE TFG_Datos
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

-- Creacin de la tabla CANDIDATO
prompt Creando la tabla Candidato ......
CREATE TABLE CANDIDATO(
  ID_CONVOCATORIA		VARCHAR2(20 BYTE) NOT NULL,
  ID_PADRON				VARCHAR2(20 BYTE) NOT NULL,
  ID_DEMARCACION		NUMBER(15) NOT NULL,
  ID_PARTIDO			NUMBER(3) NOT NULL,
  ORDEN					NUMBER(3) NOT NULL,

  CONSTRAINT PK_CANDIDATO PRIMARY KEY (ID_CONVOCATORIA,ID_PADRON,ID_DEMARCACION,ID_PARTIDO),
  CONSTRAINT CANDIDATO_CHK1 CHECK (ORDEN > 0),

  CONSTRAINT CANDIDATO_CENSO_FK
    FOREIGN KEY (ID_CONVOCATORIA,ID_PADRON)
    REFERENCES CENSO_ELECTORAL (ID_CONVOCATORIA,ID_PADRON),

  CONSTRAINT CANDIDATO_CANDIDATURA_FK
    FOREIGN KEY (ID_DEMARCACION,ID_PARTIDO)
    REFERENCES CANDIDATURA (ID_DEMARCACION,ID_PARTIDO)
)
TABLESPACE TFG_Datos
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

-- Creacin de la tabla LOG_PADRON
prompt Creando la tabla Log_Padron ......
CREATE TABLE LOG_PADRON(
  ID_LOG				NUMBER(15) NOT NULL,
  FECHA					DATE NOT NULL,
  ID_USUARIO			VARCHAR2(20 BYTE) NOT NULL,
  ID_PADRON				VARCHAR2(20 BYTE) NOT NULL,
  
  CONSTRAINT PK_LOG_PADRON PRIMARY KEY (ID_LOG), 

  CONSTRAINT LOG_PADRON_USUA_FK
    FOREIGN KEY (ID_USUARIO)
    REFERENCES USUARIOS (ID_USUARIO),

  CONSTRAINT LOG_PADRON_PADRON_FK
    FOREIGN KEY (ID_PADRON)
    REFERENCES PADRON_MUNICIPAL (ID_PADRON)
)  
TABLESPACE TFG_Datos
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            INITIAL          64K
            MINEXTENTS       1
            MAXEXTENTS       UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;

-- Creacin de la tabla temporal para el escrutinio
prompt Creando la tabla temporal TEMP_RESULTADOS ......
CREATE GLOBAL TEMPORARY TABLE TEMP_RESULTADOS (
	PARTIDO				NUMBER(3) NOT NULL,
	ESCANOS				NUMBER(3) NOT NULL,
	VOTOS				NUMBER(9) NOT NULL,
	VOTO_ESCANO			NUMBER(9) NOT NULL,
	PORCENTAJE_VOTOS	NUMBER(5,2) NOT NULL
)
ON COMMIT DELETE ROWS;

spool off;
