spool 10_pk_ABM.log

prompt creando packages pk_ABM...

CREATE OR REPLACE PACKAGE PK_ABM AS
/******************************************************************************
   NOMBRE:   PK_ABM
   DESCRIPCIoN: PAQUETE DE PROCEDIMIENTOS ABM DE LAS ENTIDADES DE LA BBDD

******************************************************************************/

  /**************************************
   *  MANTENIMIENTO COMUNIDAD_AUTONOMA
   **************************************/
  PROCEDURE ALTA_COMUNIDAD_AUTONOMA (
	pIdautonomia IN COMUNIDAD_AUTONOMA.ID_AUTONOMIA%TYPE,
	pDescripcion IN COMUNIDAD_AUTONOMA.DESCRIPCION%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE BAJA_COMUNIDAD_AUTONOMA (
	pIdautonomia IN COMUNIDAD_AUTONOMA.ID_AUTONOMIA%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE MODIF_COMUNIDAD_AUTONOMA (
	pIdautonomia IN COMUNIDAD_AUTONOMA.ID_AUTONOMIA%TYPE,
	pDescripcion IN COMUNIDAD_AUTONOMA.DESCRIPCION%TYPE,
	RSP OUT VARCHAR2);

  /**************************************
   *  MANTENIMIENTO PROVINCIA
   **************************************/
  PROCEDURE ALTA_PROVINCIA (
	pIdautonomia IN COMUNIDAD_AUTONOMA.ID_AUTONOMIA%TYPE,
	pIdprovincia IN PROVINCIA.ID_PROVINCIA%TYPE,
	pDescripcion IN PROVINCIA.DESCRIPCION%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE BAJA_PROVINCIA (
	pIdprovincia IN PROVINCIA.ID_PROVINCIA%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE MODIFICACION_PROVINCIA (
	pIdprovincia IN PROVINCIA.ID_PROVINCIA%TYPE,
	pDescripcion IN PROVINCIA.DESCRIPCION%TYPE,
	RSP OUT VARCHAR2);

  /**************************************
   *  MANTENIMIENTO MUNICIPIO
   **************************************/
  PROCEDURE ALTA_MUNICIPIO (
	pIdprovincia IN PROVINCIA.ID_PROVINCIA%TYPE,
	pIdmunicipio IN MUNICIPIO.ID_MUNICIPIO%TYPE,
	pDescripcion IN MUNICIPIO.DESCRIPCION%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE BAJA_MUNICIPIO (
	pIdmunicipio IN MUNICIPIO.ID_MUNICIPIO%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE MODIFICACION_MUNICIPIO (
	pIdmunicipio IN MUNICIPIO.ID_MUNICIPIO%TYPE,
	pDescripcion IN MUNICIPIO.DESCRIPCION%TYPE,
	RSP OUT VARCHAR2);

  /**************************************
   *  MANTENIMIENTO TITULACION
   **************************************/
  PROCEDURE ALTA_TITULACION (
	pIdtitulacion IN TITULACION.ID_TITULACION%TYPE,
	pDescripcion IN TITULACION.DESCRIPCION%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE BAJA_TITULACION (
	pIdtitulacion IN TITULACION.ID_TITULACION%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE MODIFICACION_TITULACION (
	pIdtitulacion IN TITULACION.ID_TITULACION%TYPE,
	pDescripcion IN TITULACION.DESCRIPCION%TYPE,
	RSP OUT VARCHAR2);

  /**************************************
   *  MANTENIMIENTO PARAMETROS
   **************************************/
  PROCEDURE ALTA_PARAMETROS (
	pIdparametro IN PARAMETROS.ID_PARAMETRO%TYPE,
	pTipo IN PARAMETROS.TIPO%TYPE,
	pCampo IN PARAMETROS.CAMPO%TYPE,
	pValor IN PARAMETROS.VALOR%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE BAJA_PARAMETROS (
	pIdparametro IN PARAMETROS.ID_PARAMETRO%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE MODIFICACION_PARAMETROS (
	pIdparametro IN PARAMETROS.ID_PARAMETRO%TYPE,
	pValor IN PARAMETROS.VALOR%TYPE,
	RSP OUT VARCHAR2);

  /**************************************
   *  MANTENIMIENTO PARTIDO_POLITICO
   **************************************/
  PROCEDURE ALTA_PARTIDO_POLITICO (
	pIdpartido IN PARTIDO_POLITICO.ID_PARTIDO%TYPE,
	pSiglas IN PARTIDO_POLITICO.SIGLAS%TYPE,
	pNombre IN PARTIDO_POLITICO.NOMBRE%TYPE,
	pDireccion IN PARTIDO_POLITICO.DIRECCION%TYPE,
	pFecinscripcion IN PARTIDO_POLITICO.FECHA_INSCRIPCION%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE BAJA_PARTIDO_POLITICO (
	pIdpartido IN PARTIDO_POLITICO.ID_PARTIDO%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE MODIFICACION_PARTIDO_POLITICO (
	pIdpartido IN PARTIDO_POLITICO.ID_PARTIDO%TYPE,
	pSiglas IN PARTIDO_POLITICO.SIGLAS%TYPE,
	pNombre IN PARTIDO_POLITICO.NOMBRE%TYPE,
	pDireccion IN PARTIDO_POLITICO.DIRECCION%TYPE,
	pFecinscripcion IN PARTIDO_POLITICO.FECHA_INSCRIPCION%TYPE,
	RSP OUT VARCHAR2);

  /**************************************
   *  MANTENIMIENTO USUARIOS
   **************************************/
  PROCEDURE ALTA_USUARIOS (
	pIdusuario IN USUARIOS.ID_USUARIO%TYPE,
	pClave IN USUARIOS.CLAVE%TYPE,
	pNivel IN USUARIOS.NIVEL%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE BAJA_USUARIOS (
	pIdusuario IN USUARIOS.ID_USUARIO%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE MODIFICACION_USUARIOS (
	pIdusuario IN USUARIOS.ID_USUARIO%TYPE,
	pClave IN USUARIOS.CLAVE%TYPE,
	pNivel IN USUARIOS.NIVEL%TYPE,
	pEstado IN USUARIOS.ESTADO%TYPE,
	RSP OUT VARCHAR2);

  /**************************************
   *  MANTENIMIENTO CONVOCATORIA
   **************************************/
  PROCEDURE ALTA_CONVOCATORIA (
	pIdconvocatoria IN CONVOCATORIA.ID_CONVOCATORIA%TYPE,
	pDescripcion IN CONVOCATORIA.DESCRIPCION%TYPE,
	pFpublicacion IN CONVOCATORIA.FECHA_PUBLICACION%TYPE,
	pFinicio IN CONVOCATORIA.FECHA_INICIO%TYPE,
	pFfin IN CONVOCATORIA.FECHA_FIN%TYPE,
	pTipo IN CONVOCATORIA.TIPO%TYPE,
	pAutonomia IN CONVOCATORIA.AUTONOMIA%TYPE,
	pNumescanos IN CONVOCATORIA.NUMERO_ESCANOS%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE BAJA_CONVOCATORIA (
	pIdconvocatoria IN CONVOCATORIA.ID_CONVOCATORIA%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE MODIFICACION_CONVOCATORIA (
	pIdconvocatoria IN CONVOCATORIA.ID_CONVOCATORIA%TYPE,
	pDescripcion IN CONVOCATORIA.DESCRIPCION%TYPE,
	pFpublicacion IN CONVOCATORIA.FECHA_PUBLICACION%TYPE,
	pFinicio IN CONVOCATORIA.FECHA_INICIO%TYPE,
	pFfin IN CONVOCATORIA.FECHA_FIN%TYPE,
	pTipo IN CONVOCATORIA.TIPO%TYPE,
	pAutonomia IN CONVOCATORIA.AUTONOMIA%TYPE,
	pNumescanos IN CONVOCATORIA.NUMERO_ESCANOS%TYPE,
	pEstado IN CONVOCATORIA.ESTADO%TYPE,
	RSP OUT VARCHAR2);

  /*******************************************
   *  MANTENIMIENTO CONVOCATORIA_PARAMETROS
   *******************************************/
  PROCEDURE ALTA_CONVOCATORIA_PARAMETROS (
	pIdconvocatoria IN CONVOCATORIA_PARAMETROS.ID_CONVOCATORIA%TYPE,
	pIddparametro IN CONVOCATORIA_PARAMETROS.ID_PARAMETRO%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE BAJA_CONVOCATORIA_PARAMETROS (
	pIdconvocatoria IN CONVOCATORIA_PARAMETROS.ID_CONVOCATORIA%TYPE,
	pIddparametro IN CONVOCATORIA_PARAMETROS.ID_PARAMETRO%TYPE,
	RSP OUT VARCHAR2);

  /**************************************
   *  MANTENIMIENTO PADRON_MUNICIPAL
   **************************************/
  PROCEDURE ALTA_PADRON_MUNICIPAL (
	pIdpadron IN PADRON_MUNICIPAL.ID_PADRON%TYPE,
	pNombre IN PADRON_MUNICIPAL.NOMBRE%TYPE,
	pApellido1 IN PADRON_MUNICIPAL.APELLIDO1%TYPE,
	pApellido2 IN PADRON_MUNICIPAL.APELLIDO2%TYPE,
	pNumdoc IN PADRON_MUNICIPAL.NUM_DOCUMENTO%TYPE,
	pFecnac IN PADRON_MUNICIPAL.FECHA_NACIMIENTO%TYPE,
	pProvnac IN PADRON_MUNICIPAL.PROVINCIA_NACIMIENTO%TYPE,
	pMunnac IN PADRON_MUNICIPAL.MUNICIPIO_NACIMIENTO%TYPE,
	pPais IN PADRON_MUNICIPAL.PAIS%TYPE,
	pSexo IN PADRON_MUNICIPAL.SEXO%TYPE,
	pProvdomic IN PADRON_MUNICIPAL.PROVINCIA_DOMICILIO%TYPE,
	pMundomic IN PADRON_MUNICIPAL.MUNICIPIO_DOMICILIO%TYPE,
	pDireccion IN PADRON_MUNICIPAL.DIRECCION%TYPE,
	pIdtitulacion IN PADRON_MUNICIPAL.TITULACION%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE BAJA_PADRON_MUNICIPAL (
	pIdpadron IN PADRON_MUNICIPAL.ID_PADRON%TYPE,
	pNumdoc IN PADRON_MUNICIPAL.NUM_DOCUMENTO%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE MODIFICACION_PADRON_MUNICIPAL (
	pIdpadron IN PADRON_MUNICIPAL.ID_PADRON%TYPE,
	pNumdoc IN PADRON_MUNICIPAL.NUM_DOCUMENTO%TYPE,
	pProvdomic IN PADRON_MUNICIPAL.PROVINCIA_DOMICILIO%TYPE,
	pMundomic IN PADRON_MUNICIPAL.MUNICIPIO_DOMICILIO%TYPE,
	pDireccion IN PADRON_MUNICIPAL.DIRECCION%TYPE,
	pIdtitulacion IN PADRON_MUNICIPAL.TITULACION%TYPE,
	RSP OUT VARCHAR2);

  /**************************************
   *  MANTENIMIENTO DEMARCACION
   **************************************/
  PROCEDURE ALTA_DEMARCACION (
	pEscanos IN DEMARCACION.ESCANOS%TYPE,
	pVotantes IN DEMARCACION.VOTANTES%TYPE,
	pIdconvocatoria IN DEMARCACION.ID_CONVOCATORIA%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE BAJA_DEMARCACION (
	pIddemarcacion IN DEMARCACION.ID_DEMARCACION%TYPE,
	pIdconvocatoria IN DEMARCACION.ID_CONVOCATORIA%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE MODIFICACION_DEMARCACION (
	pIddemarcacion IN DEMARCACION.ID_DEMARCACION%TYPE,
	pEscanos IN DEMARCACION.ESCANOS%TYPE,
	pVotantes IN DEMARCACION.VOTANTES%TYPE,
	pIdconvocatoria IN DEMARCACION.ID_CONVOCATORIA%TYPE,
	RSP OUT VARCHAR2);

  /**************************************
   *  MANTENIMIENTO CENTRO_VOTACION
   **************************************/
  PROCEDURE ALTA_CENTRO_VOTACION (
	pIddemarcacion IN CENTRO_VOTACION.ID_DEMARCACION%TYPE,
	pIdmunicipio IN CENTRO_VOTACION.ID_MUNICIPIO%TYPE,
	pDistrito IN CENTRO_VOTACION.DISTRITO%TYPE,
	pSeccion IN CENTRO_VOTACION.SECCION%TYPE,
	pDireccion IN CENTRO_VOTACION.DIRECCION%TYPE,
	pCodpostal IN CENTRO_VOTACION.CODIGO_POSTAL%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE BAJA_CENTRO_VOTACION (
	pIddemarcacion IN CENTRO_VOTACION.ID_DEMARCACION%TYPE,
	pIdmunicipio IN CENTRO_VOTACION.ID_MUNICIPIO%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE MODIFICACION_CENTRO_VOTACION (
	pIddemarcacion IN CENTRO_VOTACION.ID_DEMARCACION%TYPE,
	pIdmunicipio IN CENTRO_VOTACION.ID_MUNICIPIO%TYPE,
	pDistrito IN CENTRO_VOTACION.DISTRITO%TYPE,
	pSeccion IN CENTRO_VOTACION.SECCION%TYPE,
	pDireccion IN CENTRO_VOTACION.DIRECCION%TYPE,
	pCodpostal IN CENTRO_VOTACION.CODIGO_POSTAL%TYPE,
	pSorteado IN CENTRO_VOTACION.SORTEADO%TYPE,
	pNotificado IN CENTRO_VOTACION.NOTIFICADO%TYPE,
	RSP OUT VARCHAR2);

  /*******************************************
   *  MANTENIMIENTO MESA
   *******************************************/
  PROCEDURE ALTA_MESA (
	pDescripcion IN MESA.DESCRIPCION%TYPE,
	pIddemarcacion IN MESA.ID_DEMARCACION%TYPE,
	pIdmunicipio IN MESA.ID_MUNICIPIO%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE BAJA_MESA (
	pIdmesa IN MESA.ID_MESA%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE MODIFICACION_MESA (
	pIdmesa IN MESA.ID_MESA%TYPE,
	pDescripcion IN MESA.DESCRIPCION%TYPE,
	pEstado IN MESA.ESTADO%TYPE,
	RSP OUT VARCHAR2);

  /**************************************
   *  MANTENIMIENTO CENSO_ELECTORAL
   **************************************/
  PROCEDURE ALTA_CENSO_ELECTORAL (
	pIdconvocatoria IN CENSO_ELECTORAL.ID_CONVOCATORIA%TYPE,
	pIdpadron IN CENSO_ELECTORAL.ID_PADRON%TYPE,
	pFecInsc IN CENSO_ELECTORAL.FECHA_INSCRIPCION%TYPE,
	pIdmesa IN CENSO_ELECTORAL.ID_MESA%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE BAJA_CENSO_ELECTORAL (
	pIdconvocatoria IN CENSO_ELECTORAL.ID_CONVOCATORIA%TYPE,
	pIdpadron IN CENSO_ELECTORAL.ID_PADRON%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE MODIFICACION_CENSO_ELECTORAL (
	pIdconvocatoria IN CENSO_ELECTORAL.ID_CONVOCATORIA%TYPE,
	pIdpadron IN CENSO_ELECTORAL.ID_PADRON%TYPE,
	pEsmesa IN CENSO_ELECTORAL.ES_MESA%TYPE,
	pTipo IN CENSO_ELECTORAL.TIPO%TYPE,
	pNotificado IN CENSO_ELECTORAL.NOTIFICADO%TYPE,
	pAlega IN CENSO_ELECTORAL.ALEGA%TYPE,
	pPresentado IN CENSO_ELECTORAL.PRESENTADO%TYPE,
	RSP OUT VARCHAR2);

  /**************************************
   *  MANTENIMIENTO CANDIDATURA
   **************************************/
  PROCEDURE ALTA_CANDIDATURA (
	pIddemarcacion IN CANDIDATURA.ID_DEMARCACION%TYPE,
	pIdpartido IN CANDIDATURA.ID_PARTIDO%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE BAJA_CANDIDATURA (
	pIddemarcacion IN CANDIDATURA.ID_DEMARCACION%TYPE,
	pIdpartido IN CANDIDATURA.ID_PARTIDO%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE MODIFICACION_CANDIDATURA (
	pIddemarcacion IN CANDIDATURA.ID_DEMARCACION%TYPE,
	pIdpartido IN CANDIDATURA.ID_PARTIDO%TYPE,
	pEstado IN CANDIDATURA.ESTADO%TYPE,
	RSP OUT VARCHAR2);

  /**************************************
   *  MANTENIMIENTO CANDIDATO
   **************************************/
  PROCEDURE ALTA_CANDIDATO (
	pIdconvocatoria IN CANDIDATO.ID_CONVOCATORIA%TYPE,
	pIdpadron IN CANDIDATO.ID_PADRON%TYPE,
	pIddemarcacion IN CANDIDATO.ID_DEMARCACION%TYPE,
	pIdpartido IN CANDIDATO.ID_PARTIDO%TYPE,
	pOrden IN CANDIDATO.ORDEN%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE BAJA_CANDIDATO (
	pIdconvocatoria IN CANDIDATO.ID_CONVOCATORIA%TYPE,
	pIdpadron IN CANDIDATO.ID_PADRON%TYPE,
	pIddemarcacion IN CANDIDATO.ID_DEMARCACION%TYPE,
	pIdpartido IN CANDIDATO.ID_PARTIDO%TYPE,
	RSP OUT VARCHAR2);

  PROCEDURE MODIFICACION_CANDIDATO (
	pIdconvocatoria IN CANDIDATO.ID_CONVOCATORIA%TYPE,
	pIdpadron IN CANDIDATO.ID_PADRON%TYPE,
	pIddemarcacion IN CANDIDATO.ID_DEMARCACION%TYPE,
	pIdpartido IN CANDIDATO.ID_PARTIDO%TYPE,
	pOrden IN CANDIDATO.ORDEN%TYPE,
	RSP OUT VARCHAR2);

END PK_ABM;
/
CREATE OR REPLACE PACKAGE BODY PK_ABM AS

  /******************************************************************************
   NOMBRE:      ALTA_COMUNIDAD_AUTONOMA
   ******************************************************************************/
   PROCEDURE ALTA_COMUNIDAD_AUTONOMA (
	pIdautonomia IN COMUNIDAD_AUTONOMA.ID_AUTONOMIA%TYPE,
	pDescripcion IN COMUNIDAD_AUTONOMA.DESCRIPCION%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_AUTONOMIA: '||pIdautonomia||', DESCRIPCION: '||pDescripcion;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo de la comunidad autonoma no puede ser nulo.';
     IF pIdautonomia IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: La descripcion de la comunidad autonoma no puede ser nula.';
     IF pDescripcion IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que el registro no se haya insertado previamente
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM COMUNIDAD_AUTONOMA
        WHERE (ID_AUTONOMIA = pIdautonomia
          OR DESCRIPCION LIKE '%'||pDescripcion||'%')
          AND ROWNUM  = 1;
        RSP := 'ERROR: La comunidad autonoma ya ha sido dado de alta.';
        RAISE E_ERROR;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
            NULL;
     END;

     -- Se inserta registro en la tabla
     INSERT INTO COMUNIDAD_AUTONOMA (ID_AUTONOMIA, DESCRIPCION)
       VALUES (pIdautonomia, pDescripcion);
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE,'PK_ABM.ALTA_COMUNIDAD_AUTONOMA', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

  EXCEPTION
    WHEN E_ERROR THEN
      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PK_ABM.ALTA_COMUNIDAD_AUTONOMA', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PK_ABM.ALTA_COMUNIDAD_AUTONOMA', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

  END ALTA_COMUNIDAD_AUTONOMA;

  /******************************************************************************
   NOMBRE:      BAJA_COMUNIDAD_AUTONOMA
  ******************************************************************************/
  PROCEDURE BAJA_COMUNIDAD_AUTONOMA (
	pIdautonomia  IN COMUNIDAD_AUTONOMA.ID_AUTONOMIA%TYPE,
	RSP OUT VARCHAR2) IS
   
   E_ERROR EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_AUTONOMIA: '||pIdautonomia;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo de la comunidad autonoma no puede ser nulo.';
     IF pIdautonomia IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que la comunidad autonoma exista en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM COMUNIDAD_AUTONOMA
        WHERE ID_AUTONOMIA = pIdautonomia;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: La comunidad autonoma no existe.';
           RAISE E_ERROR;
     END;

     --Se realiza el borrado del registro si pasa las validaciones y no tiene ninguna dependencia
     BEGIN
        DELETE COMUNIDAD_AUTONOMA WHERE ID_AUTONOMIA = pIdautonomia;
     EXCEPTION
       WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
     END;
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PK_ABM.BAJA_COMUNIDAD_AUTONOMA', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PK_ABM.BAJA_COMUNIDAD_AUTONOMA', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PK_ABM.BAJA_COMUNIDAD_AUTONOMA', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END BAJA_COMUNIDAD_AUTONOMA;
  
    /******************************************************************************
   NOMBRE:      MODIF_COMUNIDAD_AUTONOMA
  ******************************************************************************/
  PROCEDURE MODIF_COMUNIDAD_AUTONOMA (
	pIdautonomia IN COMUNIDAD_AUTONOMA.ID_AUTONOMIA%TYPE,
	pDescripcion IN COMUNIDAD_AUTONOMA.DESCRIPCION%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_AUTONOMIA: '||pIdautonomia||', DESCRIPCION: '||pDescripcion;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo de la comunidad autonoma no puede ser nulo.';
     IF pIdautonomia IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: La descripcion de la comunidad autonoma no puede ser nula.';
     IF pDescripcion IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que la comunidad autonoma exista en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM COMUNIDAD_AUTONOMA
        WHERE ID_AUTONOMIA = pIdautonomia;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: La comunidad autonoma no existe';
           RAISE E_ERROR;
      END;

     --Si se pasan las pruebas de validacion actualiza
     BEGIN
	 UPDATE COMUNIDAD_AUTONOMA 
		SET DESCRIPCION = pDescripcion
     WHERE ID_AUTONOMIA = pIdautonomia;
	 EXCEPTION
		WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
	 END;
	 RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PK_ABM.MODIF_COMUNIDAD_AUTONOMA', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PK_ABM.MODIF_COMUNIDAD_AUTONOMA', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PK_ABM.MODIF_COMUNIDAD_AUTONOMA', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END MODIF_COMUNIDAD_AUTONOMA;

  /******************************************************************************
   NOMBRE:      ALTA_PROVINCIA
  ******************************************************************************/
  PROCEDURE ALTA_PROVINCIA (
	pIdautonomia IN COMUNIDAD_AUTONOMA.ID_AUTONOMIA%TYPE,
	pIdprovincia IN PROVINCIA.ID_PROVINCIA%TYPE,
	pDescripcion IN PROVINCIA.DESCRIPCION%TYPE,
	RSP OUT VARCHAR2)  IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_AUTONOMIA: '||pIdautonomia||', ID_PROVINCIA: '||pIdprovincia||', DESCRIPCION: '||pDescripcion;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo de la comunidad autonoma no puede ser nulo.';
     IF pIdautonomia IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El codigo de la provincia no puede ser nulo.';
     IF pIdprovincia IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: La descripcion de la provincia no puede ser nula.';
     IF pDescripcion IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que la comunidad autonoma exista
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM COMUNIDAD_AUTONOMA
        WHERE ID_AUTONOMIA  = pIdautonomia;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
            RSP := 'ERROR: La comunidad autonoma no existe.';
            RAISE E_ERROR;
     END;

     --Se verifica que el registro no se haya insertado previamente
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM PROVINCIA
        WHERE (ID_PROVINCIA = pIdprovincia
          OR DESCRIPCION LIKE '%'||pDescripcion||'%')
          AND ROWNUM = 1;
        RSP := 'ERROR: La provincia ya ha sido dado de alta previamente.';
        RAISE E_ERROR;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
             NULL;
     END;

     -- Se inserta registro en la tabla
     INSERT INTO PROVINCIA (ID_PROVINCIA, DESCRIPCION, ID_AUTONOMIA) 
	   VALUES (pIdprovincia, pDescripcion, pIdautonomia);
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PK_ABM.ALTA_PROVINCIA', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PK_ABM.ALTA_PROVINCIA', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PK_ABM.ALTA_PROVINCIA', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END ALTA_PROVINCIA;

  /******************************************************************************
   NOMBRE:      BAJA_PROVINCIA
  ******************************************************************************/
  PROCEDURE BAJA_PROVINCIA (
	pIdprovincia IN PROVINCIA.ID_PROVINCIA%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_PROVINCIA: '||pIdprovincia;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo de la provincia no puede ser nulo.';
     IF pIdprovincia IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que la provincia exista en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM PROVINCIA
        WHERE ID_PROVINCIA = pIdprovincia;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: La provincia no existe.';
           RAISE E_ERROR;
     END;

     --Se realiza el borrado del registro si pasa las validaciones y no tiene ninguna dependencia
     BEGIN
        DELETE PROVINCIA WHERE ID_PROVINCIA = pIdprovincia;
     EXCEPTION
       WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
     END;
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PK_ABM.BAJA_PROVINCIA', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PK_ABM.BAJA_PROVINCIA', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PK_ABM.BAJA_PROVINCIA', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END BAJA_PROVINCIA;

    /******************************************************************************
   NOMBRE:      MODIFICACION_PROVINCIA
  ******************************************************************************/
  PROCEDURE MODIFICACION_PROVINCIA (
	pIdprovincia IN PROVINCIA.ID_PROVINCIA%TYPE,
	pDescripcion IN PROVINCIA.DESCRIPCION%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_PROVINCIA: '||pIdprovincia||', DESCRIPCION: '||pDescripcion;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo de la provincia no puede ser nulo.';
     IF pIdprovincia IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: La descripcion de la provincia no puede ser nula.';
     IF pDescripcion IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que la provincia exista en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM PROVINCIA
        WHERE ID_PROVINCIA = pIdprovincia;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: La provincia no existe.';
           RAISE E_ERROR;
      END;

     --Si se pasan las pruebas de validacion actualiza
     BEGIN
	 UPDATE PROVINCIA S
		SET DESCRIPCION = pDescripcion
     WHERE ID_PROVINCIA = pIdprovincia;
	 EXCEPTION
		WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
	 END;
	 RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PK_ABM.MODIFICACION_PROVINCIA', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PK_ABM.MODIFICACION_PROVINCIA', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PK_ABM.MODIFICACION_PROVINCIA', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END MODIFICACION_PROVINCIA;

  /******************************************************************************
   NOMBRE:      ALTA_MUNICIPIO
  ******************************************************************************/
  PROCEDURE ALTA_MUNICIPIO (
	pIdprovincia IN PROVINCIA.ID_PROVINCIA%TYPE,
	pIdmunicipio IN MUNICIPIO.ID_MUNICIPIO%TYPE,
	pDescripcion IN MUNICIPIO.DESCRIPCION%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_PROVINCIA: '||pIdprovincia||', ID_MUNICIPIO: '||pIdmunicipio||', DESCRIPCION: '||pDescripcion;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo de la provincia no puede ser nulo.';
     IF pIdprovincia IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El codigo del municipio no puede ser nulo.';
     IF pIdmunicipio IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: La descripcion del municipio no puede ser nulo.';
     IF pDescripcion IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que la provincia exista
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM PROVINCIA
        WHERE ID_PROVINCIA  = pIdprovincia;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
            RSP := 'ERROR: La provincia no existe.';
            RAISE E_ERROR;
     END;

     --Se verifica que el registro no se haya insertado previamente
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM MUNICIPIO
        WHERE (ID_MUNICIPIO = pIdmunicipio
          OR DESCRIPCION LIKE '%'||pDescripcion||'%')
		  AND ID_PROVINCIA = pIdprovincia
          AND ROWNUM = 1;
        RSP := 'ERROR: El municipio ya ha sido dado de alta previamente.';
        RAISE E_ERROR;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
             NULL;
     END;

     -- Se inserta registro en la tabla
     INSERT INTO MUNICIPIO (ID_MUNICIPIO, DESCRIPCION, ID_PROVINCIA) 
	   VALUES (pIdmunicipio, pDescripcion, pIdprovincia);
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PK_ABM.ALTA_MUNICIPIO', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PK_ABM.ALTA_MUNICIPIO', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PK_ABM.ALTA_MUNICIPIO', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END ALTA_MUNICIPIO;

  /******************************************************************************
   NOMBRE:      BAJA_MUNICIPIO
  ******************************************************************************/
  PROCEDURE BAJA_MUNICIPIO (
	pIdmunicipio IN MUNICIPIO.ID_MUNICIPIO%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_MUNICIPIO: '||pIdmunicipio;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo del municipio no puede ser nulo.';
     IF pIdmunicipio IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que el municipio existe en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM MUNICIPIO
        WHERE ID_MUNICIPIO = pIdmunicipio;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: El municipio no existe.';
           RAISE E_ERROR;
     END;

     --Se realiza el borrado del registro si pasa las validaciones y no tiene ninguna dependencia
     BEGIN
        DELETE MUNICIPIO WHERE ID_MUNICIPIO = pIdmunicipio;
     EXCEPTION
       WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
     END;
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PK_ABM.BAJA_MUNICIPIO', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PK_ABM.BAJA_MUNICIPIO', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PK_ABM.BAJA_MUNICIPIO', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END BAJA_MUNICIPIO;

    /******************************************************************************
   NOMBRE:      MODIFICACION_MUNICIPIO
  ******************************************************************************/
  PROCEDURE MODIFICACION_MUNICIPIO (
	pIdmunicipio IN MUNICIPIO.ID_MUNICIPIO%TYPE,
	pDescripcion IN MUNICIPIO.DESCRIPCION%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_MUNICIPIO: '||pIdmunicipio||', DESCRIPCION: '||pDescripcion;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo del municipio no puede ser nulo.';
     IF pIdmunicipio IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: La descripcion del municipio no puede ser nula.';
     IF pDescripcion IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que el municipio exista en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM MUNICIPIO
        WHERE ID_MUNICIPIO = pIdmunicipio;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: El municipio no existe';
           RAISE E_ERROR;
      END;

     --Si se pasan las pruebas de validacion actualiza
     BEGIN
	 UPDATE MUNICIPIO 
		SET DESCRIPCION = pDescripcion
     WHERE ID_MUNICIPIO = pIdmunicipio;
	 EXCEPTION
		WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
	 END;
	 RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PK_ABM.MODIFICACION_MUNICIPIO', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PK_ABM.MODIFICACION_MUNICIPIO', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PK_ABM.MODIFICACION_MUNICIPIO', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END MODIFICACION_MUNICIPIO;

  /******************************************************************************
   NOMBRE:      ALTA_TITULACION
   ******************************************************************************/
   PROCEDURE ALTA_TITULACION (
	pIdtitulacion IN TITULACION.ID_TITULACION%TYPE,
	pDescripcion IN TITULACION.DESCRIPCION%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_TITULACION: '||pIdtitulacion||', DESCRIPCION: '||pDescripcion;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo de la titulacion no puede ser nulo.';
     IF pIdtitulacion IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: La descripcion de la titulacion no puede ser nula.';
     IF pDescripcion IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que el registro no se haya insertado previamente
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM TITULACION
        WHERE (ID_TITULACION = pIdtitulacion
          OR DESCRIPCION LIKE '%'||pDescripcion||'%')
          AND ROWNUM  = 1;
        RSP := 'ERROR: La titulacion ya ha sido dado de alta.';
        RAISE E_ERROR;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
            NULL;
     END;

     -- Se inserta registro en la tabla
     INSERT INTO TITULACION (ID_TITULACION, DESCRIPCION)
       VALUES (pIdtitulacion, pDescripcion);
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE,'PK_ABM.ALTA_TITULACION', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

  EXCEPTION
    WHEN E_ERROR THEN
      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PK_ABM.ALTA_TITULACION', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PK_ABM.ALTA_TITULACION', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

  END ALTA_TITULACION;

  /******************************************************************************
   NOMBRE:      BAJA_TITULACION
  ******************************************************************************/
  PROCEDURE BAJA_TITULACION (
	pIdtitulacion IN TITULACION.ID_TITULACION%TYPE,
	RSP OUT VARCHAR2) IS
   
   E_ERROR EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_TITULACION: '||pIdtitulacion;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo de la titulacion no puede ser nulo.';
     IF pIdtitulacion IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que la titulacion exista en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM TITULACION
        WHERE ID_TITULACION = pIdtitulacion;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: La titulacion no existe.';
           RAISE E_ERROR;
     END;

     --Se realiza el borrado del registro si pasa las validaciones y no tiene ninguna dependencia
     BEGIN
        DELETE TITULACION WHERE ID_TITULACION = pIdtitulacion;
     EXCEPTION
       WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
     END;
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PK_ABM.BAJA_TITULACION', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PK_ABM.BAJA_TITULACION', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PK_ABM.BAJA_TITULACION', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END BAJA_TITULACION;
  
    /******************************************************************************
   NOMBRE:      MODIFICACION_TITULACION
  ******************************************************************************/
  PROCEDURE MODIFICACION_TITULACION (
	pIdtitulacion IN TITULACION.ID_TITULACION%TYPE,
	pDescripcion IN TITULACION.DESCRIPCION%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_TITULACION: '||pIdtitulacion||', DESCRIPCION: '||pDescripcion;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo de la titulacion no puede ser nulo.';
     IF pIdtitulacion IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: La descripcion de la titulacion no puede ser nula.';
     IF pDescripcion IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que la titulacion exista en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM TITULACION
        WHERE ID_TITULACION = pIdtitulacion;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: La titulacion no existe';
           RAISE E_ERROR;
      END;

     --Si se pasan las pruebas de validacion actualiza
     BEGIN
	 UPDATE TITULACION 
		SET DESCRIPCION = pDescripcion
     WHERE ID_TITULACION = pIdtitulacion;
 	 EXCEPTION
		WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
	 END;
	 RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PK_ABM.MODIFICACION_TITULACION', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PK_ABM.MODIFICACION_TITULACION', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PK_ABM.MODIFICACION_TITULACION', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END MODIFICACION_TITULACION;

  /******************************************************************************
   NOMBRE:      ALTA_PARAMETROS
   ******************************************************************************/
   PROCEDURE ALTA_PARAMETROS (
	pIdparametro IN PARAMETROS.ID_PARAMETRO%TYPE,
	pTipo IN PARAMETROS.TIPO%TYPE,
	pCampo IN PARAMETROS.CAMPO%TYPE,
	pValor IN PARAMETROS.VALOR%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_PARAMETRO: '||pIdparametro||', TIPO: '||pTipo||', CAMPO: '||pCampo||', VALOR: '||pValor;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo del parametro no puede ser nulo.';
     IF pIdparametro IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El tipo del parametro no puede ser nulo.';
     IF pTipo IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El valor del tipo de parametro es incorrecto. Valores correctos: PARTIDO, CENSO, MESA, ESCRUTINIO' ;
     IF pTipo NOT IN ('PARTIDO','CENSO','MESA', 'ESCRUTINIO')  THEN  RAISE E_ERROR; END IF;

     RSP := 'ERROR: El campo del parametro no puede ser nulo.';
     IF pCampo IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El valor del parametro no puede ser nulo.';
     IF pValor IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que el registro no se haya insertado previamente
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM PARAMETROS
        WHERE ID_PARAMETRO = pIdparametro
          AND ROWNUM  = 1;
        RSP := 'ERROR: El parametro ya ha sido dado de alta.';
        RAISE E_ERROR;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
            NULL;
     END;

     -- Se inserta registro en la tabla
     INSERT INTO PARAMETROS (ID_PARAMETRO, TIPO, CAMPO, VALOR)
       VALUES (pIdparametro, pTipo, pCampo, pValor);
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE,'PK_ABM.ALTA_PARAMETROS', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

  EXCEPTION
    WHEN E_ERROR THEN
      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PK_ABM.ALTA_PARAMETROS', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PK_ABM.ALTA_PARAMETROS', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

  END ALTA_PARAMETROS;

  /******************************************************************************
   NOMBRE:      BAJA_PARAMETROS
  ******************************************************************************/
  PROCEDURE BAJA_PARAMETROS (
	pIdparametro IN PARAMETROS.ID_PARAMETRO%TYPE,
	RSP OUT VARCHAR2) IS
   
   E_ERROR EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_PARAMETRO: '||pIdparametro;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo del parametro no puede ser nulo.';
     IF pIdparametro IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que el parametro exista en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM PARAMETROS
        WHERE ID_PARAMETRO = pIdparametro;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: El parametro no existe.';
           RAISE E_ERROR;
     END;

     --Se realiza el borrado del registro si pasa las validaciones y no tiene ninguna dependencia
     BEGIN
        DELETE PARAMETROS WHERE ID_PARAMETRO = pIdparametro;
     EXCEPTION
       WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
     END;
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PK_ABM.BAJA_PARAMETROS', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PK_ABM.BAJA_PARAMETROS', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PK_ABM.BAJA_PARAMETROS', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END BAJA_PARAMETROS;
  
    /******************************************************************************
   NOMBRE:      MODIFICACION_PARAMETROS
  ******************************************************************************/
  PROCEDURE MODIFICACION_PARAMETROS (
	pIdparametro IN PARAMETROS.ID_PARAMETRO%TYPE,
	pValor IN PARAMETROS.VALOR%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_PARAMETRO: '||pIdparametro||', VALOR: '||pValor;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo del parametro no puede ser nulo.';
     IF pIdparametro IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El valor del parametro no puede ser nulo.';
     IF pValor IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que el parametro exista en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM PARAMETROS
        WHERE ID_PARAMETRO = pIdparametro;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: El parametro no existe.';
           RAISE E_ERROR;
      END;

     --Si se pasan las pruebas de validacion actualiza
     BEGIN
	 UPDATE PARAMETROS 
		SET VALOR = pValor
     WHERE ID_PARAMETRO = pIdparametro;
 	 EXCEPTION
		WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
	 END;
	 RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PK_ABM.MODIFICACION_PARAMETROS', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PK_ABM.MODIFICACION_PARAMETROS', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PK_ABM.MODIFICACION_PARAMETROS', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END MODIFICACION_PARAMETROS;

  /******************************************************************************
   NOMBRE:      ALTA_PARTIDO_POLITICO
   ******************************************************************************/
   PROCEDURE ALTA_PARTIDO_POLITICO (
	pIdpartido IN PARTIDO_POLITICO.ID_PARTIDO%TYPE,
	pSiglas IN PARTIDO_POLITICO.SIGLAS%TYPE,
	pNombre IN PARTIDO_POLITICO.NOMBRE%TYPE,
	pDireccion IN PARTIDO_POLITICO.DIRECCION%TYPE,
	pFecinscripcion IN PARTIDO_POLITICO.FECHA_INSCRIPCION%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_PARTIDO: '||pIdpartido||', SIGLAS: '||pSiglas||', NOMBRE: '||pNombre||', DIRECCION: '||pDireccion||', FECHA_INSCRIPCION: '||pFecinscripcion;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo del partido politico no puede ser nulo.';
     IF pIdpartido IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: Las siglas del partido politico no puede ser nulo.';
     IF pSiglas IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El nombre del partido politico no puede ser nulo.';
     IF pNombre IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: La direccion del partido politico no puede ser nulo.';
     IF pDireccion IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: La fecha de inscripcion del partido politico no puede ser nulo.';
     IF pFecinscripcion IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que el registro no se haya insertado previamente
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM PARTIDO_POLITICO
        WHERE (ID_PARTIDO = pIdpartido
		  OR SIGLAS = pSiglas
		  OR NOMBRE = pNombre)
          AND ROWNUM  = 1;
        RSP := 'ERROR: El partido politico ya ha sido dado de alta.';
        RAISE E_ERROR;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
            NULL;
     END;

     -- Se inserta registro en la tabla
     INSERT INTO PARTIDO_POLITICO (ID_PARTIDO, SIGLAS, NOMBRE, DIRECCION, FECHA_INSCRIPCION)
       VALUES (pIdpartido, pSiglas, pNombre, pDireccion, pFecinscripcion);
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE,'PK_ABM.ALTA_PARTIDO_POLITICO', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

  EXCEPTION
    WHEN E_ERROR THEN
      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PK_ABM.ALTA_PARTIDO_POLITICO', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PK_ABM.ALTA_PARTIDO_POLITICO', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

  END ALTA_PARTIDO_POLITICO;

  /******************************************************************************
   NOMBRE:      BAJA_PARTIDO_POLITICO
  ******************************************************************************/
  PROCEDURE BAJA_PARTIDO_POLITICO (
	pIdpartido IN PARTIDO_POLITICO.ID_PARTIDO%TYPE,
	RSP OUT VARCHAR2) IS
   
   E_ERROR EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_PARTIDO: '||pIdpartido;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo del partido politico no puede ser nulo.';
     IF pIdpartido IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que el partido politico exista en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM PARTIDO_POLITICO
        WHERE ID_PARTIDO = pIdpartido;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: El partido politico no existe.';
           RAISE E_ERROR;
     END;

     --Se realiza el borrado del registro si pasa las validaciones y no tiene ninguna dependencia
     BEGIN
        DELETE PARTIDO_POLITICO WHERE ID_PARTIDO = pIdpartido;
     EXCEPTION
       WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
     END;
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PK_ABM.BAJA_PARTIDO_POLITICO', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PK_ABM.BAJA_PARTIDO_POLITICO', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PK_ABM.BAJA_PARTIDO_POLITICO', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END BAJA_PARTIDO_POLITICO;
  
    /******************************************************************************
   NOMBRE:      MODIFICACION_PARTIDO_POLITICO
  ******************************************************************************/
  PROCEDURE MODIFICACION_PARTIDO_POLITICO (
	pIdpartido IN PARTIDO_POLITICO.ID_PARTIDO%TYPE,
	pSiglas IN PARTIDO_POLITICO.SIGLAS%TYPE,
	pNombre IN PARTIDO_POLITICO.NOMBRE%TYPE,
	pDireccion IN PARTIDO_POLITICO.DIRECCION%TYPE,
	pFecinscripcion IN PARTIDO_POLITICO.FECHA_INSCRIPCION%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_PARTIDO: '||pIdpartido||', SIGLAS: '||pSiglas||', NOMBRE: '||pNombre||', DIRECCION: '||pDireccion||', FECHA_INSCRIPCION: '||pFecinscripcion;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo del partido politico no puede ser nulo.';
     IF pIdpartido IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: Las siglas del partido politico no puede ser nulo.';
     IF pSiglas IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El nombre del partido politico no puede ser nulo.';
     IF pNombre IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: La direccion del partido politico no puede ser nulo.';
     IF pDireccion IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: La fecha de inscripcion del partido politico no puede ser nulo.';
     IF pFecinscripcion IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que el partido politico exista en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM PARTIDO_POLITICO
        WHERE ID_PARTIDO = pIdpartido;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: El partido politico no existe.';
           RAISE E_ERROR;
      END;

     --Si se pasan las pruebas de validacion actualiza
     BEGIN
	 UPDATE PARTIDO_POLITICO 
		SET SIGLAS = pSiglas, NOMBRE = pNombre, DIRECCION = pDireccion, FECHA_INSCRIPCION = pFecinscripcion
     WHERE ID_PARTIDO = pIdpartido;
 	 EXCEPTION
		WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
	 END;
	 RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PK_ABM.MODIFICACION_PARTIDO_POLITICO', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PK_ABM.MODIFICACION_PARTIDO_POLITICO', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PK_ABM.MODIFICACION_PARTIDO_POLITICO', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END MODIFICACION_PARTIDO_POLITICO;
  
  /******************************************************************************
   NOMBRE:      ALTA_USUARIOS
   ******************************************************************************/
   PROCEDURE ALTA_USUARIOS (
	pIdusuario IN USUARIOS.ID_USUARIO%TYPE,
	pClave IN USUARIOS.CLAVE%TYPE,
	pNivel IN USUARIOS.NIVEL%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_USUARIO: '||pIdusuario||', CLAVE: '||pClave||', NIVEL: '||pNivel;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo del usuario no puede ser nulo.';
     IF pIdusuario IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: La clave del usuario no puede ser nula.';
     IF pClave IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El nivel del usuario no puede ser nulo.';
     IF pNivel IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El valor del nivel del usuario es incorrecto. Valores correctos: NORMAL, AVANZADO';
     IF pNivel NOT IN ('NORMAL','AVANZADO')  THEN  RAISE E_ERROR; END IF;

     --Se verifica que el registro no se haya insertado previamente
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM USUARIOS
        WHERE ID_USUARIO = pIdusuario
          AND ROWNUM  = 1;
        RSP := 'ERROR: El usuario ya ha sido dado de alta.';
        RAISE E_ERROR;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
            NULL;
     END;

     -- Se inserta registro en la tabla con el estado "ACTIVO"
     INSERT INTO USUARIOS (ID_USUARIO, CLAVE, NIVEL, ESTADO)
       VALUES (pIdusuario, pClave, pNivel, 'HABILITADO');
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE,'PK_ABM.ALTA_USUARIOS', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

  EXCEPTION
    WHEN E_ERROR THEN
      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PK_ABM.ALTA_USUARIOS', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PK_ABM.ALTA_USUARIOS', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

  END ALTA_USUARIOS;

  /******************************************************************************
   NOMBRE:      BAJA_USUARIOS
  ******************************************************************************/
  PROCEDURE BAJA_USUARIOS (
	pIdusuario IN USUARIOS.ID_USUARIO%TYPE,
	RSP OUT VARCHAR2) IS
   
   E_ERROR EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_USUARIO: '||pIdusuario;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo del usuario no puede ser nulo.';
     IF pIdusuario IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que el usuario exista en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM USUARIOS
        WHERE ID_USUARIO = pIdusuario;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: El usuario no existe.';
           RAISE E_ERROR;
     END;

     --Se actualiza el valor del estado a "BAJA"
     BEGIN
     UPDATE USUARIOS 
		SET ESTADO = 'DESHABILITADO' 
	 WHERE ID_USUARIO = pIdusuario;
     EXCEPTION
       WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
     END;
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PK_ABM.BAJA_USUARIOS', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PK_ABM.BAJA_USUARIOS', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PK_ABM.BAJA_USUARIOS', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END BAJA_USUARIOS;
  
    /******************************************************************************
   NOMBRE:      MODIFICACION_USUARIOS
  ******************************************************************************/
  PROCEDURE MODIFICACION_USUARIOS (
	pIdusuario IN USUARIOS.ID_USUARIO%TYPE,
	pClave IN USUARIOS.CLAVE%TYPE,
	pNivel IN USUARIOS.NIVEL%TYPE,
	pEstado IN USUARIOS.ESTADO%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_USUARIO: '||pIdusuario||', CLAVE: '||pClave||', NIVEL: '||pNivel||', ESTADO: '||pEstado;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo del usuario no puede ser nulo.';
     IF pIdusuario IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: La clave del usuario no puede ser nula.';
     IF pClave IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El nivel del usuario no puede ser nulo.';
     IF pNivel IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El valor del nivel del usuario es incorrecto. Valores correctos: NORMAL, AVANZADO';
     IF pNivel NOT IN ('NORMAL','AVANZADO')  THEN  RAISE E_ERROR; END IF;

     RSP := 'ERROR: El estado del usuario no puede ser nulo.';
     IF pEstado IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El valor del estado del usuario es incorrecto. Valores correctos: HABILITADO, DESHABILITADO';
     IF pEstado NOT IN ('HABILITADO','DESHABILITADO')  THEN  RAISE E_ERROR; END IF;

     --Se verifica que el usuario exista en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM USUARIOS
        WHERE ID_USUARIO = pIdusuario;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: El usuario no existe.';
           RAISE E_ERROR;
      END;

     --Si se pasan las pruebas de validacion actualiza
     BEGIN
	 UPDATE USUARIOS 
		SET CLAVE = pClave, NIVEL = pNivel, ESTADO = pEstado
     WHERE ID_USUARIO = pIdusuario;
 	 EXCEPTION
		WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
	 END;
	 RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PK_ABM.MODIFICACION_USUARIOS', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PK_ABM.MODIFICACION_USUARIOS', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PK_ABM.MODIFICACION_USUARIOS', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END MODIFICACION_USUARIOS;

  /******************************************************************************
   NOMBRE:      ALTA_CONVOCATORIA
   ******************************************************************************/
   PROCEDURE ALTA_CONVOCATORIA (
	pIdconvocatoria IN CONVOCATORIA.ID_CONVOCATORIA%TYPE,
	pDescripcion IN CONVOCATORIA.DESCRIPCION%TYPE,
	pFpublicacion IN CONVOCATORIA.FECHA_PUBLICACION%TYPE,
	pFinicio IN CONVOCATORIA.FECHA_INICIO%TYPE,
	pFfin IN CONVOCATORIA.FECHA_FIN%TYPE,
	pTipo IN CONVOCATORIA.TIPO%TYPE,
	pAutonomia IN CONVOCATORIA.AUTONOMIA%TYPE,
	pNumescanos IN CONVOCATORIA.NUMERO_ESCANOS%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_CONVOCATORIA: '||pIdconvocatoria||', DESCRIPCION: '||pDescripcion||', FECHA_PUBLICACION: '||pFpublicacion||
		', FECHA_INICIO: '||pFinicio||', FECHA_FIN: '||pFfin||', TIPO: '||pTipo||', AUTONOMIA: '||pAutonomia||', NUMERO_ESCANOS: '||pNumescanos;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo de la convocatoria no puede ser nulo.';
     IF pIdconvocatoria IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: La descripcion de la convocatoria no puede ser nula.';
     IF pDescripcion IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: La fecha de publicacion de la convocatoria no puede ser nula.';
     IF pFpublicacion IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: La fecha de inicio de la convocatoria no puede ser nula.';
     IF pFinicio IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: La fecha de finalizacion de la convocatoria no puede ser nula.';
     IF pFfin IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El tipo de convocatoria no puede ser nulo.';
     IF pTipo IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El valor del tipo de convocatoria es incorrecto. Valores correctos: ESTATAL, AUTONOMICA, MUNICIPAL';
     IF pTipo NOT IN ('ESTATAL','AUTONOMICA','MUNICIPAL')  THEN  RAISE E_ERROR; END IF;

     RSP := 'ERROR: El valor de la autonomia no puede ser nulo si el tipo de convocatoria es autonomica.';
     IF pTipo = 'AUTONOMICA' AND pAutonomia IS NULL THEN  RAISE E_ERROR; END IF;

     RSP := 'ERROR: El numero de escaños de la convocatoria no puede ser nulo o menor que CERO.';
     IF pNumescanos IS NULL OR pNumescanos <= 0 THEN RAISE E_ERROR; END IF;

     --Se verifica que la comunidad autonoma exista en base de datos
	 IF pTipo = 'AUTONOMICA' THEN
		BEGIN
			SELECT 'S'
				INTO EXISTE
			FROM COMUNIDAD_AUTONOMA
			WHERE ID_AUTONOMIA = pAutonomia;
			EXCEPTION
				WHEN NO_DATA_FOUND THEN
					RSP := 'ERROR: La comunidad autonoma no existe.';
					RAISE E_ERROR;
		END;
	 END IF;

     --Se verifica que el registro no se haya insertado previamente
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM CONVOCATORIA
        WHERE ID_CONVOCATORIA = pIdconvocatoria
          AND ROWNUM  = 1;
        RSP := 'ERROR: La convocatoria ya ha sido dado de alta.';
        RAISE E_ERROR;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
            NULL;
     END;

     -- Se inserta registro en la tabla con el estado "ABIERTA"
     INSERT INTO CONVOCATORIA (ID_CONVOCATORIA, DESCRIPCION, FECHA_PUBLICACION, FECHA_INICIO, FECHA_FIN, TIPO, AUTONOMIA, NUMERO_ESCANOS, ESTADO)
       VALUES (pIdconvocatoria, pDescripcion, pFpublicacion,  pFinicio, pFfin, pTipo, pAutonomia, pNumescanos, 'ABIERTA');
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE,'PK_ABM.ALTA_CONVOCATORIA', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

  EXCEPTION
    WHEN E_ERROR THEN
      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PK_ABM.ALTA_CONVOCATORIA', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PK_ABM.ALTA_CONVOCATORIA', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

  END ALTA_CONVOCATORIA;

  /******************************************************************************
   NOMBRE:      BAJA_CONVOCATORIA
  ******************************************************************************/
  PROCEDURE BAJA_CONVOCATORIA (
	pIdconvocatoria IN CONVOCATORIA.ID_CONVOCATORIA%TYPE,
	RSP OUT VARCHAR2) IS
   
   E_ERROR EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_CONVOCATORIA: '||pIdconvocatoria;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo de la convocatoria no puede ser nulo.';
     IF pIdconvocatoria IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que la convocatoria exista en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM CONVOCATORIA
        WHERE ID_CONVOCATORIA = pIdconvocatoria;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: La convocatoria no existe.';
           RAISE E_ERROR;
     END;

     --Se actualiza el valor del estado a "ANULADA"
     BEGIN
     UPDATE CONVOCATORIA 
		SET ESTADO = 'ANULADA' 
	 WHERE ID_CONVOCATORIA = pIdconvocatoria;
     EXCEPTION
       WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
     END;
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PK_ABM.BAJA_CONVOCATORIA', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PK_ABM.BAJA_CONVOCATORIA', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PK_ABM.BAJA_CONVOCATORIA', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END BAJA_CONVOCATORIA;
  
    /******************************************************************************
   NOMBRE:      MODIFICACION_CONVOCATORIA
  ******************************************************************************/
  PROCEDURE MODIFICACION_CONVOCATORIA (
	pIdconvocatoria IN CONVOCATORIA.ID_CONVOCATORIA%TYPE,
	pDescripcion IN CONVOCATORIA.DESCRIPCION%TYPE,
	pFpublicacion IN CONVOCATORIA.FECHA_PUBLICACION%TYPE,
	pFinicio IN CONVOCATORIA.FECHA_INICIO%TYPE,
	pFfin IN CONVOCATORIA.FECHA_FIN%TYPE,
	pTipo IN CONVOCATORIA.TIPO%TYPE,
	pAutonomia IN CONVOCATORIA.AUTONOMIA%TYPE,
	pNumescanos IN CONVOCATORIA.NUMERO_ESCANOS%TYPE,
	pEstado IN CONVOCATORIA.ESTADO%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_CONVOCATORIA: '||pIdconvocatoria||', DESCRIPCION: '||pDescripcion||', FECHA_PUBLICACION: '||pFpublicacion||', FECHA_INICIO: '||pFinicio||
		', FECHA_FIN: '||pFfin||', TIPO: '||pTipo||', AUTONOMIA: '||pAutonomia||', NUMERO_ESCANOS: '||pNumescanos||', ESTADO: '||pEstado;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo de la convocatoria no puede ser nulo.';
     IF pIdconvocatoria IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: La descripcion de la convocatoria no puede ser nula.';
     IF pDescripcion IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: La fecha de publicacion de la convocatoria no puede ser nula.';
     IF pFpublicacion IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: La fecha de inicio de la convocatoria no puede ser nula.';
     IF pFinicio IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: La fecha de finalizacion de la convocatoria no puede ser nula.';
     IF pFfin IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El tipo de convocatoria no puede ser nulo.';
     IF pTipo IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El valor del tipo de convocatoria es incorrecto. Valores correctos: ESTATAL, AUTONOMICA, MUNICIPAL';
     IF pTipo NOT IN ('ESTATAL','AUTONOMICA','MUNICIPAL')  THEN  RAISE E_ERROR; END IF;

     RSP := 'ERROR: El valor de la autonomia no puede ser nulo si el tipo de convocatoria es autonomica.';
     IF pTipo = 'AUTONOMICA' AND pAutonomia IS NULL THEN  RAISE E_ERROR; END IF;

     RSP := 'ERROR: El numero de escaños de la convocatoria no puede ser nulo o menor que CERO.';
     IF pNumescanos IS NULL OR pNumescanos < 0 THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El estado de la convocatoria no puede ser nulo.';
     IF pEstado IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El estado de la convocatoria es incorrecto. Valores correctos: ABIERTA, CERRADA, FINALIZADA, ANULADA';
     IF pEstado NOT IN ('ABIERTA','CERRADA','FINALIZADA', 'ANULADA')  THEN  RAISE E_ERROR; END IF;

     --Se verifica que la convocatoria exista en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM CONVOCATORIA
        WHERE ID_CONVOCATORIA = pIdconvocatoria;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: La convocatoria no existe.';
           RAISE E_ERROR;
      END;

     --Se verifica que la comunidad autonoma exista en base de datos
	 IF pTipo = 'AUTONOMICA' THEN
		BEGIN
			SELECT 'S'
				INTO EXISTE
			FROM COMUNIDAD_AUTONOMA
			WHERE ID_AUTONOMIA = pAutonomia;
			EXCEPTION
				WHEN NO_DATA_FOUND THEN
					RSP := 'ERROR: La comunidad autonoma no existe.';
					RAISE E_ERROR;
		END;
	 END IF;

     --Si se pasan las pruebas de validacion actualiza
     BEGIN
	 UPDATE CONVOCATORIA 
		SET DESCRIPCION = pDescripcion, FECHA_PUBLICACION = pFpublicacion, FECHA_INICIO = pFinicio, 
		FECHA_FIN = pFfin, TIPO = pTipo, AUTONOMIA = pAutonomia, NUMERO_ESCANOS = pNumescanos, ESTADO = pEstado
	 WHERE ID_CONVOCATORIA = pIdconvocatoria;
 	 EXCEPTION
		WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
	 END;
	 RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PK_ABM.MODIFICACION_CONVOCATORIA', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PK_ABM.MODIFICACION_CONVOCATORIA', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PK_ABM.MODIFICACION_CONVOCATORIA', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END MODIFICACION_CONVOCATORIA;

  /******************************************************************************
   NOMBRE:      ALTA_CONVOCATORIA_PARAMETROS
   ******************************************************************************/
   PROCEDURE ALTA_CONVOCATORIA_PARAMETROS (
	pIdconvocatoria IN CONVOCATORIA_PARAMETROS.ID_CONVOCATORIA%TYPE,
	pIddparametro IN CONVOCATORIA_PARAMETROS.ID_PARAMETRO%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_CONVOCATORIA: '||pIdconvocatoria||', ID_PARAMETRO: '||pIddparametro;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo de la convocatoria no puede ser nulo.';
     IF pIdconvocatoria IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El codigo del parametro no puede ser nulo.';
     IF pIddparametro IS NULL THEN RAISE E_ERROR; END IF;

	--Se verifica que la convocatoria exista en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM CONVOCATORIA
        WHERE ID_CONVOCATORIA = pIdconvocatoria;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: La convocatoria no existe.';
           RAISE E_ERROR;
      END;

	--Se verifica que el parametro exista en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM PARAMETROS
        WHERE ID_PARAMETRO = pIddparametro;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: El parametro no existe.';
           RAISE E_ERROR;
      END;

     --Se verifica que el registro no se haya insertado previamente
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM CONVOCATORIA_PARAMETROS
        WHERE ID_CONVOCATORIA = pIdconvocatoria
          AND ID_PARAMETRO = pIddparametro
          AND ROWNUM  = 1;
        RSP := 'ERROR: El parametro ya ha sido dado de alta para esa convocatoria.';
        RAISE E_ERROR;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
            NULL;
     END;

     -- Se inserta registro en la tabla
     INSERT INTO CONVOCATORIA_PARAMETROS (ID_CONVOCATORIA, ID_PARAMETRO)
       VALUES (pIdconvocatoria, pIddparametro);
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE,'PK_ABM.ALTA_CONVOCATORIA_PARAMETROS', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

  EXCEPTION
    WHEN E_ERROR THEN
      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PK_ABM.ALTA_CONVOCATORIA_PARAMETROS', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PK_ABM.ALTA_CONVOCATORIA_PARAMETROS', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

  END ALTA_CONVOCATORIA_PARAMETROS;

 /******************************************************************************
   NOMBRE:      BAJA_CONVOCATORIA_PARAMETROS
  ******************************************************************************/
  PROCEDURE BAJA_CONVOCATORIA_PARAMETROS (
	pIdconvocatoria IN CONVOCATORIA_PARAMETROS.ID_CONVOCATORIA%TYPE,
	pIddparametro IN CONVOCATORIA_PARAMETROS.ID_PARAMETRO%TYPE,
	RSP OUT VARCHAR2) IS
   
   E_ERROR EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_CONVOCATORIA: '||pIdconvocatoria||', ID_PARAMETRO: '||pIddparametro;

     --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo de la convocatoria no puede ser nulo.';
     IF pIdconvocatoria IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El codigo del parametro no puede ser nulo.';
     IF pIddparametro IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que el parametro exista en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM CONVOCATORIA_PARAMETROS
        WHERE ID_CONVOCATORIA = pIdconvocatoria
			AND ID_PARAMETRO = pIddparametro;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: El parametro no existe para esa convocatoria.';
           RAISE E_ERROR;
     END;

     --Se realiza el borrado del registro si pasa las validaciones
     BEGIN
        DELETE CONVOCATORIA_PARAMETROS 
		WHERE ID_CONVOCATORIA = pIdconvocatoria
			AND ID_PARAMETRO = pIddparametro;
     EXCEPTION
       WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
     END;
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PK_ABM.BAJA_CONVOCATORIA_PARAMETROS', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PK_ABM.BAJA_CONVOCATORIA_PARAMETROS', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PK_ABM.BAJA_CONVOCATORIA_PARAMETROS', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END BAJA_CONVOCATORIA_PARAMETROS;
  
  /******************************************************************************
   NOMBRE:      ALTA_PADRON_MUNICIPAL
   ******************************************************************************/
   PROCEDURE ALTA_PADRON_MUNICIPAL (
	pIdpadron IN PADRON_MUNICIPAL.ID_PADRON%TYPE,
	pNombre IN PADRON_MUNICIPAL.NOMBRE%TYPE,
	pApellido1 IN PADRON_MUNICIPAL.APELLIDO1%TYPE,
	pApellido2 IN PADRON_MUNICIPAL.APELLIDO2%TYPE,
	pNumdoc IN PADRON_MUNICIPAL.NUM_DOCUMENTO%TYPE,
	pFecnac IN PADRON_MUNICIPAL.FECHA_NACIMIENTO%TYPE,
	pProvnac IN PADRON_MUNICIPAL.PROVINCIA_NACIMIENTO%TYPE,
	pMunnac IN PADRON_MUNICIPAL.MUNICIPIO_NACIMIENTO%TYPE,
	pPais IN PADRON_MUNICIPAL.PAIS%TYPE,
	pSexo IN PADRON_MUNICIPAL.SEXO%TYPE,
	pProvdomic IN PADRON_MUNICIPAL.PROVINCIA_DOMICILIO%TYPE,
	pMundomic IN PADRON_MUNICIPAL.MUNICIPIO_DOMICILIO%TYPE,
	pDireccion IN PADRON_MUNICIPAL.DIRECCION%TYPE,
	pIdtitulacion IN PADRON_MUNICIPAL.TITULACION%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(700);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_PADRON: '||pIdpadron||', NOMBRE: '||pNombre||', APELLIDO1: '||pApellido1||', APELLIDO2: '||pApellido2||', NUM_DOCUMENTO: '||
		pNumdoc||', FECHA_NACIMIENTO: '||pFecnac||', PROVINCIA_NACIMIENTO: '||pProvnac||', MUNICIPIO_NACIMIENTO: '||pMunnac||', PAIS: '||
		pPais||', SEXO: '||pSexo||', PROVINCIA_DOMICILIO: '||pProvdomic||', MUNICIPIO_DOMICILIO: '||pMundomic||', DIRECCION: '||pDireccion||', TITULACION: '||pIdtitulacion;
     
	 --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo del padron no puede ser nulo.';
     IF pIdpadron IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El nombre de la persona no puede ser nulo.';
     IF pNombre IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El primer apellido de la persona no puede ser nulo.';
     IF pApellido1 IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El numero de documento de la persona no puede ser nulo.';
     IF pNumdoc IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: La fecha de nacimiento de la persona no puede ser nulo.';
     IF pFecnac IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: La provincia de nacimiento de la persona no puede ser nulo.';
     IF pProvnac IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El municipio de nacimiento de la persona no puede ser nulo.';
     IF pMunnac IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El pais de la persona no puede ser nulo.';
     IF pPais IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El sexo de la persona no puede ser nulo.';
     IF pSexo IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El sexo de la persona es incorrecto. Valores correctos: HOMBRE, MUJER';
     IF pSexo NOT IN ('HOMBRE','MUJER')  THEN  RAISE E_ERROR; END IF;

     RSP := 'ERROR: La provincia del domicilio de la persona no puede ser nulo.';
     IF pProvdomic IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El municipio del domicilio de la persona no puede ser nulo.';
     IF pMundomic IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: La direccion del domicilio de la persona no puede ser nulo.';
     IF pDireccion IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El codigo de la titulacion de la persona no puede ser nulo.';
     IF pIdtitulacion IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que el registro no se haya insertado previamente
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM PADRON_MUNICIPAL
        WHERE (ID_PADRON = pIdpadron
		  OR NUM_DOCUMENTO = pNumdoc)
          AND ROWNUM  = 1;
        RSP := 'ERROR: La persona ya ha sido dado de alta.';
        RAISE E_ERROR;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
            NULL;
     END;

     --Se verifica que la provincia del domicilio exista.
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM PROVINCIA
        WHERE ID_PROVINCIA = pProvdomic;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: La provincia del domicilio no existe.';
           RAISE E_ERROR;
     END;

     --Se verifica que el municipio del domicilio exista.
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM MUNICIPIO
        WHERE ID_PROVINCIA = pProvdomic
		  AND ID_MUNICIPIO = pMundomic;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: El municipio del domicilio no existe.';
           RAISE E_ERROR;
     END;

     --Se verifica que la titulación exista.
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM TITULACION
        WHERE ID_TITULACION = pIdtitulacion;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: La titulacion no existe.';
           RAISE E_ERROR;
     END;

     -- Se inserta registro en la tabla
     INSERT INTO PADRON_MUNICIPAL (ID_PADRON, NOMBRE, APELLIDO1, APELLIDO2, NUM_DOCUMENTO, FECHA_NACIMIENTO, 
		PROVINCIA_NACIMIENTO, MUNICIPIO_NACIMIENTO, PAIS, SEXO, PROVINCIA_DOMICILIO, MUNICIPIO_DOMICILIO, DIRECCION, TITULACION)
       VALUES (pIdpadron, pNombre, pApellido1, pApellido2, pNumdoc, pFecnac, pProvnac, pMunnac, pPais, pSexo, pProvdomic, pMundomic, pDireccion, pIdtitulacion);
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE,'PK_ABM.ALTA_PADRON_MUNICIPAL', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

  EXCEPTION
    WHEN E_ERROR THEN
      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PK_ABM.ALTA_PADRON_MUNICIPAL', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PK_ABM.ALTA_PADRON_MUNICIPAL', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

  END ALTA_PADRON_MUNICIPAL;

  /******************************************************************************
   NOMBRE:      BAJA_PADRON_MUNICIPAL
  ******************************************************************************/
  PROCEDURE BAJA_PADRON_MUNICIPAL (
	pIdpadron IN PADRON_MUNICIPAL.ID_PADRON%TYPE,
	pNumdoc IN PADRON_MUNICIPAL.NUM_DOCUMENTO%TYPE,
	RSP OUT VARCHAR2) IS
   
   E_ERROR EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_PADRON: '||pIdpadron||', NUM_DOCUMENTO: '||pNumdoc;

     --Se verifica que alguno de los parametros tenga valor
     RSP := 'ERROR: Ambos parametros de entrada no puede ser nulos.';
     IF pIdpadron IS NULL AND pNumdoc IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que la persona exista en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM PADRON_MUNICIPAL
        WHERE (ID_PADRON = pIdpadron
		  OR NUM_DOCUMENTO = pNumdoc);
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: La persona no existe.';
           RAISE E_ERROR;
     END;

     --Se realiza el borrado del registro si pasa las validaciones y no tiene ninguna dependencia
     BEGIN
        DELETE PADRON_MUNICIPAL WHERE ID_PADRON = pIdpadron;
     EXCEPTION
       WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
     END;
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PK_ABM.BAJA_PADRON_MUNICIPAL', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PK_ABM.BAJA_PADRON_MUNICIPAL', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PK_ABM.BAJA_PADRON_MUNICIPAL', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END BAJA_PADRON_MUNICIPAL;
  
  /******************************************************************************
   NOMBRE:      MODIFICACION_PADRON_MUNICIPAL
  ******************************************************************************/
  PROCEDURE MODIFICACION_PADRON_MUNICIPAL (
	pIdpadron IN PADRON_MUNICIPAL.ID_PADRON%TYPE,
	pNumdoc IN PADRON_MUNICIPAL.NUM_DOCUMENTO%TYPE,
	pProvdomic IN PADRON_MUNICIPAL.PROVINCIA_DOMICILIO%TYPE,
	pMundomic IN PADRON_MUNICIPAL.MUNICIPIO_DOMICILIO%TYPE,
	pDireccion IN PADRON_MUNICIPAL.DIRECCION%TYPE,
	pIdtitulacion IN PADRON_MUNICIPAL.TITULACION%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_PADRON: '||pIdpadron||', PROVINCIA_DOMICILIO: '||pProvdomic||', MUNICIPIO_DOMICILIO: '||pMundomic||', DIRECCION: '||pDireccion||', TITULACION: '||pIdtitulacion;

	 --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo de padron y el numero de documento no pueden ser nulos.';
     IF pIdpadron IS NULL AND pNumdoc IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: La provincia del domicilio de la persona no puede ser nulo.';
     IF pProvdomic IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El municipio del domicilio de la persona no puede ser nulo.';
     IF pMundomic IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: La direccion del domicilio de la persona no puede ser nulo.';
     IF pDireccion IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El codigo de la titulacion de la persona no puede ser nulo.';
     IF pIdtitulacion IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que la persona exista en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM PADRON_MUNICIPAL
        WHERE (ID_PADRON = pIdpadron
		  OR NUM_DOCUMENTO = pNumdoc);
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: La persona no existe.';
           RAISE E_ERROR;
      END;

     --Se verifica que la provincia del domicilio exista.
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM PROVINCIA
        WHERE ID_PROVINCIA = pProvdomic;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: La provincia del domicilio no existe.';
           RAISE E_ERROR;
     END;

     --Se verifica que el municipio del domicilio exista.
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM MUNICIPIO
        WHERE ID_PROVINCIA = pProvdomic
		  AND ID_MUNICIPIO = pMundomic;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: El municipio del domicilio no existe.';
           RAISE E_ERROR;
     END;

     --Se verifica que la titulación exista.
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM TITULACION
        WHERE ID_TITULACION = pIdtitulacion;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: La titulacion no existe.';
           RAISE E_ERROR;
     END;

     --Si se pasan las pruebas de validacion actualiza
     BEGIN
	 UPDATE PADRON_MUNICIPAL 
		SET PROVINCIA_DOMICILIO = pProvdomic, 
			MUNICIPIO_DOMICILIO = pMundomic, 
			DIRECCION = pDireccion, 
			TITULACION = pIdtitulacion 
     WHERE (ID_PADRON = pIdpadron
		  OR NUM_DOCUMENTO = pNumdoc);
 	 EXCEPTION
		WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
	 END;
	 RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PK_ABM.MODIFICACION_PADRON_MUNICIPAL', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PK_ABM.MODIFICACION_PADRON_MUNICIPAL', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PK_ABM.MODIFICACION_PADRON_MUNICIPAL', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END MODIFICACION_PADRON_MUNICIPAL;

  /******************************************************************************
   NOMBRE:      ALTA_DEMARCACION
   ******************************************************************************/
   PROCEDURE ALTA_DEMARCACION (
	pEscanos IN DEMARCACION.ESCANOS%TYPE,
	pVotantes IN DEMARCACION.VOTANTES%TYPE,
	pIdconvocatoria IN DEMARCACION.ID_CONVOCATORIA%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ESCANOS: '||pEscanos||', VOTANTES: '||pVotantes||', ID_CONVOCATORIA: '||pIdconvocatoria;
     
	 --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El numero de escaños de la demarcacion no puede ser nulo.';
     IF pEscanos IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El numero de votantes no puede ser nulo.';
     IF pVotantes IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El codigo de la convocatoria no puede ser nulo.';
     IF pIdconvocatoria IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El numero de escaños y/o numero de votantes no puede ser menor o igual que CERO.';
     IF pEscanos <= 0 OR pVotantes <= 0 THEN RAISE E_ERROR; END IF;

     -- Se inserta registro en la tabla
     INSERT INTO DEMARCACION (ESCANOS, VOTANTES, ID_CONVOCATORIA)
       VALUES (pEscanos, pVotantes, pIdconvocatoria);
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE,'PK_ABM.ALTA_DEMARCACION', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

  EXCEPTION
    WHEN E_ERROR THEN
      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PK_ABM.ALTA_DEMARCACION', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PK_ABM.ALTA_DEMARCACION', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

  END ALTA_DEMARCACION;

  /******************************************************************************
   NOMBRE:      BAJA_DEMARCACION
  ******************************************************************************/
  PROCEDURE BAJA_DEMARCACION (
	pIddemarcacion IN DEMARCACION.ID_DEMARCACION%TYPE,
	pIdconvocatoria IN DEMARCACION.ID_CONVOCATORIA%TYPE,
	RSP OUT VARCHAR2) IS
   
   E_ERROR EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_DEMARCACION: '||pIddemarcacion||', ID_CONVOCATORIA: '||pIdconvocatoria;

     --Se verifica que alguno de los parametros tenga valor
     RSP := 'ERROR: El codigo de la demarcacion no puede ser nulo.';
     IF pIddemarcacion IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El codigo de la convocatoria no puede ser nulo.';
     IF pIdconvocatoria IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que la demarcacion exista en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM DEMARCACION
        WHERE ID_CONVOCATORIA = pIdconvocatoria
		  AND ID_DEMARCACION = pIddemarcacion;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: La demarcacion no existe.';
           RAISE E_ERROR;
     END;

     --Se elimina la demarcacion de la base de datos
     BEGIN
        DELETE DEMARCACION 
		WHERE ID_CONVOCATORIA = pIdconvocatoria 
			AND ID_DEMARCACION = pIddemarcacion;
     EXCEPTION
       WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
     END;
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PK_ABM.BAJA_DEMARCACION', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PK_ABM.BAJA_DEMARCACION', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PK_ABM.BAJA_DEMARCACION', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END BAJA_DEMARCACION;
  
 /******************************************************************************
   NOMBRE:      MODIFICACION_DEMARCACION
  ******************************************************************************/
  PROCEDURE MODIFICACION_DEMARCACION (
	pIddemarcacion IN DEMARCACION.ID_DEMARCACION%TYPE,
	pEscanos IN DEMARCACION.ESCANOS%TYPE,
	pVotantes IN DEMARCACION.VOTANTES%TYPE,
	pIdconvocatoria IN DEMARCACION.ID_CONVOCATORIA%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_DEMARCACION: '||pIddemarcacion||', ESCANOS: '||pEscanos||', VOTANTES: '||pVotantes||', ID_CONVOCATORIA: '||pIdconvocatoria;
     
	 --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo de la demarcacion no puede ser nulo.';
     IF pIddemarcacion IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El numero de escaños de la demarcacion no puede ser nulo.';
     IF pEscanos IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El numero de votantes no puede ser nulo.';
     IF pVotantes IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El codigo de la convocatoria no puede ser nulo.';
     IF pIdconvocatoria IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El numero de escaños y/o numero de votantes no puede ser menor o igual que CERO.';
     IF pEscanos <= 0 OR pVotantes <= 0 THEN RAISE E_ERROR; END IF;

     --Se verifica que la demarcacion exista en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM DEMARCACION
        WHERE ID_CONVOCATORIA = pIdconvocatoria
		  AND ID_DEMARCACION = pIddemarcacion;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: La demarcacion no existe.';
           RAISE E_ERROR;
      END;

     --Si se pasan las pruebas de validacion actualiza
     BEGIN
	 UPDATE DEMARCACION 
		SET ESCANOS = pEscanos, VOTANTES = pVotantes
     WHERE ID_CONVOCATORIA = pIdconvocatoria
	    AND ID_DEMARCACION = pIddemarcacion;
 	 EXCEPTION
		WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
	 END;
	 RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PK_ABM.MODIFICACION_DEMARCACION', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PK_ABM.MODIFICACION_DEMARCACION', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PK_ABM.MODIFICACION_DEMARCACION', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END MODIFICACION_DEMARCACION;

  /******************************************************************************
   NOMBRE:      ALTA_CENTRO_VOTACION
   ******************************************************************************/
   PROCEDURE ALTA_CENTRO_VOTACION (
	pIddemarcacion IN CENTRO_VOTACION.ID_DEMARCACION%TYPE,
	pIdmunicipio IN CENTRO_VOTACION.ID_MUNICIPIO%TYPE,
	pDistrito IN CENTRO_VOTACION.DISTRITO%TYPE,
	pSeccion IN CENTRO_VOTACION.SECCION%TYPE,
	pDireccion IN CENTRO_VOTACION.DIRECCION%TYPE,
	pCodpostal IN CENTRO_VOTACION.CODIGO_POSTAL%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_DEMARCACION: '||pIddemarcacion||', ID_MUNICIPIO: '||pIdmunicipio||', DISTRITO: '||pDistrito||', SECCION: '||pSeccion||', DIRECCION: '||pDireccion||', CODIGO_POSTAL: '||pCodpostal;
     
	 --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo de la demarcacion no puede ser nulo.';
     IF pIddemarcacion IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El codigo del municipio no puede ser nulo.';
     IF pIdmunicipio IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El distrito no puede ser nulo.';
     IF pDistrito IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: La seccion no puede ser nulo.';
     IF pSeccion IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: La direccion del centro no puede ser nulo.';
     IF pDireccion IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El codigo postal no puede ser nulo.';
     IF pCodpostal IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que el registro no se haya insertado previamente
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM CENTRO_VOTACION
        WHERE ID_DEMARCACION = pIddemarcacion
		  AND ID_MUNICIPIO = pIdmunicipio
          AND ROWNUM  = 1;
        RSP := 'ERROR: El centro de votacion ya ha sido dado de alta.';
        RAISE E_ERROR;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
            NULL;
     END;

     -- Se inserta registro en la tabla
     INSERT INTO CENTRO_VOTACION (ID_DEMARCACION, ID_MUNICIPIO, DISTRITO, SECCION, DIRECCION, CODIGO_POSTAL)
       VALUES (pIddemarcacion, pIdmunicipio, pDistrito, pSeccion, pDireccion, pCodpostal);
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE,'PK_ABM.ALTA_CENTRO_VOTACION', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

  EXCEPTION
    WHEN E_ERROR THEN
      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PK_ABM.ALTA_CENTRO_VOTACION', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PK_ABM.ALTA_CENTRO_VOTACION', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

  END ALTA_CENTRO_VOTACION;

  /******************************************************************************
   NOMBRE:      BAJA_CENTRO_VOTACION
  ******************************************************************************/
  PROCEDURE BAJA_CENTRO_VOTACION (
	pIddemarcacion IN CENTRO_VOTACION.ID_DEMARCACION%TYPE,
	pIdmunicipio IN CENTRO_VOTACION.ID_MUNICIPIO%TYPE,
	RSP OUT VARCHAR2) IS
   
   E_ERROR EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_DEMARCACION: '||pIddemarcacion||', ID_MUNICIPIO: '||pIdmunicipio;

     --Se verifica que alguno de los parametros tenga valor
     RSP := 'ERROR: El codigo de la demarcacion no puede ser nulo.';
     IF pIddemarcacion IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El codigo del municipio no puede ser nulo.';
     IF pIdmunicipio IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que la persona exista en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM CENTRO_VOTACION
        WHERE ID_DEMARCACION = pIddemarcacion
		  AND ID_MUNICIPIO = pIdmunicipio;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: El centro de votacion no existe.';
           RAISE E_ERROR;
     END;

     --Si el centro de votacion no tiene dependencias se elimina
     BEGIN
        DELETE CENTRO_VOTACION 
		WHERE ID_DEMARCACION = pIddemarcacion 
			AND ID_MUNICIPIO = pIdmunicipio;
     EXCEPTION
       WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
     END;
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PK_ABM.BAJA_CENTRO_VOTACION', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PK_ABM.BAJA_CENTRO_VOTACION', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PK_ABM.BAJA_CENTRO_VOTACION', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END BAJA_CENTRO_VOTACION;
  
  /******************************************************************************
   NOMBRE:      MODIFICACION_CENTRO_VOTACION
  ******************************************************************************/
  PROCEDURE MODIFICACION_CENTRO_VOTACION (
	pIddemarcacion IN CENTRO_VOTACION.ID_DEMARCACION%TYPE,
	pIdmunicipio IN CENTRO_VOTACION.ID_MUNICIPIO%TYPE,
	pDistrito IN CENTRO_VOTACION.DISTRITO%TYPE,
	pSeccion IN CENTRO_VOTACION.SECCION%TYPE,
	pDireccion IN CENTRO_VOTACION.DIRECCION%TYPE,
	pCodpostal IN CENTRO_VOTACION.CODIGO_POSTAL%TYPE,
	pSorteado IN CENTRO_VOTACION.SORTEADO%TYPE,
	pNotificado IN CENTRO_VOTACION.NOTIFICADO%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_DEMARCACION: '||pIddemarcacion||', ID_MUNICIPIO: '||pIdmunicipio||', DISTRITO: '||pDistrito||', SECCION: '||pSeccion||
		', DIRECCION: '||pDireccion||', CODIGO_POSTAL: '||pCodpostal||', SORTEADO: '||pSorteado||', NOTIFICADO: '||pNotificado;
     
	 --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo de la demarcacion no puede ser nulo.';
     IF pIddemarcacion IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El codigo del municipio no puede ser nulo.';
     IF pIdmunicipio IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El distrito no puede ser nulo.';
     IF pDistrito IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: La seccion no puede ser nulo.';
     IF pSeccion IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: La direccion del centro no puede ser nulo.';
     IF pDireccion IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El codigo postal no puede ser nulo.';
     IF pCodpostal IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El identificador de sorteado no puede ser nulo.';
     IF pSorteado IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El identificador de notificado no puede ser nulo.';
     IF pNotificado IS NULL THEN RAISE E_ERROR; END IF;
	 
     RSP := 'ERROR: El valor del campo sorteado o notificado es incorrecto. Valores correctos: S(SI) ,N(NO)';
     IF pSorteado NOT IN ('S','N') OR pNotificado NOT IN ('S','N') THEN  RAISE E_ERROR; END IF;


     --Se verifica que el centro votacion exista en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM CENTRO_VOTACION
        WHERE ID_DEMARCACION = pIddemarcacion
		  AND ID_MUNICIPIO = pIdmunicipio;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: El centro de votacion no existe.';
           RAISE E_ERROR;
      END;

     --Si se pasan las pruebas de validacion actualiza
     BEGIN
	 UPDATE CENTRO_VOTACION 
		SET DISTRITO = pDistrito,
			SECCION = pSeccion,
			DIRECCION = pDireccion,
			CODIGO_POSTAL = pCodpostal,
			SORTEADO = pSorteado,
			NOTIFICADO = pNotificado
     WHERE ID_DEMARCACION = pIddemarcacion
		AND ID_MUNICIPIO = pIdmunicipio;
 	 EXCEPTION
		WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
	 END;
	 RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PK_ABM.MODIFICACION_CENTRO_VOTACION', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PK_ABM.MODIFICACION_CENTRO_VOTACION', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PK_ABM.MODIFICACION_CENTRO_VOTACION', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END MODIFICACION_CENTRO_VOTACION;

  /******************************************************************************
   NOMBRE:      ALTA_MESA
   ******************************************************************************/
   PROCEDURE ALTA_MESA (
	pDescripcion IN MESA.DESCRIPCION%TYPE,
	pIddemarcacion IN MESA.ID_DEMARCACION%TYPE,
	pIdmunicipio IN MESA.ID_MUNICIPIO%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'DESCRIPCION: '||pDescripcion||', ID_DEMARCACION: '||pIddemarcacion||', ID_MUNICIPIO: '||pIdmunicipio;
     
	 --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: La descripcion de la mesa no puede ser nulo.';
     IF pDescripcion IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El codigo demarcacion no puede ser nulo.';
     IF pIddemarcacion IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El codigo de municipio no puede ser nulo.';
     IF pIdmunicipio IS NULL THEN RAISE E_ERROR; END IF;

     -- Se inserta registro en la tabla
     INSERT INTO MESA (DESCRIPCION, ESTADO, ID_DEMARCACION, ID_MUNICIPIO)
       VALUES (pDescripcion, 'CERRADA', pIddemarcacion, pIdmunicipio);
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE,'PK_PRC.ALTA_MESA', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

  EXCEPTION
    WHEN E_ERROR THEN
      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PK_PRC.ALTA_MESA', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PK_PRC.ALTA_MESA', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

  END ALTA_MESA;

  /******************************************************************************
   NOMBRE:      BAJA_MESA
  ******************************************************************************/
  PROCEDURE BAJA_MESA (
	pIdmesa IN MESA.ID_MESA%TYPE,
	RSP OUT VARCHAR2) IS
   
   E_ERROR EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_MESA: '||pIdmesa;

     --Se verifica que alguno de los parametros tenga valor
     RSP := 'ERROR: El codigo de la mesa no puede ser nulo.';
     IF pIdmesa IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que la persona exista en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM MESA
        WHERE ID_MESA = pIdmesa;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: La mesa no existe.';
           RAISE E_ERROR;
     END;

     --Se actualiza el valor del estado a "ANULADA"
     BEGIN
     UPDATE MESA 
		SET ESTADO = 'ANULADA' 
	 WHERE ID_MESA = pIdmesa;
     EXCEPTION
       WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
     END;
     RSP := 'OK';
	 
     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PK_PRC.BAJA_MESA', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PK_PRC.BAJA_MESA', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PK_PRC.BAJA_MESA', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END BAJA_MESA;
  
  /******************************************************************************
   NOMBRE:      MODIFICACION_MESA
  ******************************************************************************/
  PROCEDURE MODIFICACION_MESA (
	pIdmesa IN MESA.ID_MESA%TYPE,
	pDescripcion IN MESA.DESCRIPCION%TYPE,
	pEstado IN MESA.ESTADO%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_MESA: '||pIdmesa||', DESCRIPCION: '||pDescripcion||', ESTADO: '||pEstado;
     
	 --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo de la mesa no puede ser nulo.';
     IF pIdmesa IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: La descripcion de la mesa no puede ser nulo.';
     IF pDescripcion IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El estado de la mesa no puede ser nulo.';
     IF pEstado IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El valor del estado de la mesa es incorrecto. Valores correctos: ABIERTA, CERRADA, FINALIZADA, ANULADA' ;
     IF pEstado NOT IN ('ABIERTA','CERRADA','FINALIZADA','ANULADA')  THEN  RAISE E_ERROR; END IF;

     --Se verifica que la mesa exista en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM MESA
        WHERE ID_MESA = pIdmesa;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: La mesa no existe.';
           RAISE E_ERROR;
      END;

     --Si se pasan las pruebas de validacion actualiza
     BEGIN
	 UPDATE MESA 
		SET DESCRIPCION = pDescripcion,
			ESTADO = pEstado
     WHERE ID_MESA = pIdmesa;
 	 EXCEPTION
		WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
	 END;
	 RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PK_PRC.MODIFICACION_MESA', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PK_PRC.MODIFICACION_MESA', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PK_PRC.MODIFICACION_MESA', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END MODIFICACION_MESA;

  /******************************************************************************
   NOMBRE:      ALTA_CENSO_ELECTORAL
   ******************************************************************************/
   PROCEDURE ALTA_CENSO_ELECTORAL (
	pIdconvocatoria IN CENSO_ELECTORAL.ID_CONVOCATORIA%TYPE,
	pIdpadron IN CENSO_ELECTORAL.ID_PADRON%TYPE,
	pFecInsc IN CENSO_ELECTORAL.FECHA_INSCRIPCION%TYPE,
	pIdmesa IN CENSO_ELECTORAL.ID_MESA%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_CONVOCATORIA: '||pIdconvocatoria||', ID_PADRON: '||pIdpadron||', FECHA_INSCRIPCION: '||pFecInsc||', ID_MESA: '||pIdmesa;
     
	 --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo de la convocatoria no puede ser nulo.';
     IF pIdconvocatoria IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El codigo del padron no puede ser nulo.';
     IF pIdpadron IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: La fecha de inscripcion no puede ser nulo.';
     IF pFecInsc IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El codigo de la mesa no puede ser nulo.';
     IF pIdmesa IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que el registro no se haya insertado previamente
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM CENSO_ELECTORAL
        WHERE ID_CONVOCATORIA = pIdconvocatoria
		  AND ID_PADRON = pIdpadron
          AND ROWNUM  = 1;
        RSP := 'ERROR: La persona ya ha sido dado de alta en el censo.';
        RAISE E_ERROR;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
            NULL;
     END;

     -- Se inserta registro en la tabla
     INSERT INTO CENSO_ELECTORAL (ID_CONVOCATORIA, ID_PADRON, FECHA_INSCRIPCION, ES_MESA, ID_MESA)
       VALUES (pIdconvocatoria, pIdpadron, pFecInsc, 'N', pIdmesa);
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE,'PK_ABM.ALTA_CENSO_ELECTORAL', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

  EXCEPTION
    WHEN E_ERROR THEN
      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PK_ABM.ALTA_CENSO_ELECTORAL', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PK_ABM.ALTA_CENSO_ELECTORAL', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

  END ALTA_CENSO_ELECTORAL;

  /******************************************************************************
   NOMBRE:      BAJA_CENSO_ELECTORAL
  ******************************************************************************/
  PROCEDURE BAJA_CENSO_ELECTORAL (
	pIdconvocatoria IN CENSO_ELECTORAL.ID_CONVOCATORIA%TYPE,
	pIdpadron IN CENSO_ELECTORAL.ID_PADRON%TYPE,
	RSP OUT VARCHAR2) IS
   
   E_ERROR EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_CONVOCATORIA: '||pIdconvocatoria||', ID_PADRON: '||pIdpadron;

     --Se verifica que alguno de los parametros tenga valor
     RSP := 'ERROR: El codigo de la convocatoria no puede ser nulo.';
     IF pIdconvocatoria IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El codigo del padron no puede ser nulo.';
     IF pIdpadron IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que la persona exista en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM CENSO_ELECTORAL
        WHERE ID_CONVOCATORIA = pIdconvocatoria
		  AND ID_PADRON = pIdpadron;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: La persona no existe.';
           RAISE E_ERROR;
     END;

     --Se realiza el borrado del registro si pasa las validaciones y no tiene ninguna dependencia
     BEGIN
        DELETE CENSO_ELECTORAL WHERE ID_CONVOCATORIA = pIdconvocatoria AND ID_PADRON = pIdpadron;
     EXCEPTION
       WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
     END;
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PK_ABM.BAJA_CENSO_ELECTORAL', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PK_ABM.BAJA_CENSO_ELECTORAL', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PK_ABM.BAJA_CENSO_ELECTORAL', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END BAJA_CENSO_ELECTORAL;
  
  /******************************************************************************
   NOMBRE:      MODIFICACION_CENSO_ELECTORAL
  ******************************************************************************/
  PROCEDURE MODIFICACION_CENSO_ELECTORAL (
	pIdconvocatoria IN CENSO_ELECTORAL.ID_CONVOCATORIA%TYPE,
	pIdpadron IN CENSO_ELECTORAL.ID_PADRON%TYPE,
	pEsmesa IN CENSO_ELECTORAL.ES_MESA%TYPE,
	pTipo IN CENSO_ELECTORAL.TIPO%TYPE,
	pNotificado IN CENSO_ELECTORAL.NOTIFICADO%TYPE,
	pAlega IN CENSO_ELECTORAL.ALEGA%TYPE,
	pPresentado IN CENSO_ELECTORAL.PRESENTADO%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_CONVOCATORIA: '||pIdconvocatoria||', ID_PADRON: '||pIdpadron||', ES_MESA: '||pEsmesa||', TIPO: '||pTipo||', NOTIFICADO: '||pNotificado||', ALEGA: '||pAlega||', PRESENTADO: '||pPresentado;

	 --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo de la convocatoria no puede ser nulo.';
     IF pIdconvocatoria IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El codigo del padron no puede ser nulo.';
     IF pIdpadron IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El indicador de si pertenece a una mesa electoral no puede ser nulo.';
     IF pEsmesa IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El valor del campo es_mesa es incorrecto. Valores correctos: S(SI) ,N(NO)';
     IF pEsmesa NOT IN ('S','N')  THEN  RAISE E_ERROR; END IF;

     RSP := 'ERROR: El valor del campo tipo no puede ser nulo si la persona ha sido designada para una mesa.';
     IF pEsmesa = 'S' AND pTipo IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El valor del campo tipo es incorrecto. Valores correctos: TITULAR,SUPLENTE';
     IF pEsmesa = 'S' AND pTipo NOT IN ('TITULAR','SUPLENTE')  THEN  RAISE E_ERROR; END IF;

     RSP := 'ERROR: El valor del campo notificado no puede ser nulo si la persona ha sido designada para una mesa.';
     IF pEsmesa = 'S' AND pNotificado IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El valor del campo notificado es incorrecto. Valores correctos: S(SI) ,N(NO)';
     IF pEsmesa = 'S' AND pNotificado NOT IN ('S','N')  THEN  RAISE E_ERROR; END IF;

     RSP := 'ERROR: El valor del campo alega no puede ser nulo si la persona ha sido designada para una mesa.';
     IF pEsmesa = 'S' AND pAlega IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El valor del campo alega es incorrecto. Valores correctos: S(SI) ,N(NO)';
     IF pEsmesa = 'S' AND pAlega NOT IN ('S','N')  THEN  RAISE E_ERROR; END IF;

     RSP := 'ERROR: El valor del campo presentado no puede ser nulo si la persona ha sido designada para una mesa.';
     IF pEsmesa = 'S' AND pPresentado IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El valor del campo presentado es incorrecto. Valores correctos: S(SI) ,N(NO)';
     IF pEsmesa = 'S' AND pPresentado NOT IN ('S','N')  THEN  RAISE E_ERROR; END IF;

     --Se verifica que la persona exista en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM CENSO_ELECTORAL
        WHERE ID_CONVOCATORIA = pIdconvocatoria
		  AND ID_PADRON = pIdpadron;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: La persona no existe.';
           RAISE E_ERROR;
      END;

     --Si se pasan las pruebas de validacion actualiza
     BEGIN
	 UPDATE CENSO_ELECTORAL 
		SET ES_MESA = pEsmesa, 
			TIPO = pTipo, 
			NOTIFICADO = pNotificado,
			ALEGA = pAlega,
			PRESENTADO = pPresentado 
     WHERE ID_CONVOCATORIA = pIdconvocatoria
		AND ID_PADRON = pIdpadron;
 	 EXCEPTION
		WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
	 END;
	 RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PK_ABM.MODIFICACION_CENSO_ELECTORAL', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PK_ABM.MODIFICACION_CENSO_ELECTORAL', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PK_ABM.MODIFICACION_CENSO_ELECTORAL', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END MODIFICACION_CENSO_ELECTORAL;
  
  /******************************************************************************
   NOMBRE:      ALTA_CANDIDATURA
   ******************************************************************************/
   PROCEDURE ALTA_CANDIDATURA (
	pIddemarcacion IN CANDIDATURA.ID_DEMARCACION%TYPE,
	pIdpartido IN CANDIDATURA.ID_PARTIDO%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_DEMARCACION: '||pIddemarcacion||', ID_PARTIDO: '||pIdpartido;
     
	 --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo de la demarcacion no puede ser nulo.';
     IF pIddemarcacion IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El codigo del partido politico no puede ser nulo.';
     IF pIdpartido IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que el registro no se haya insertado previamente
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM CANDIDATURA
        WHERE ID_DEMARCACION = pIddemarcacion
		  AND ID_PARTIDO = pIdpartido
          AND ROWNUM  = 1;
        RSP := 'ERROR: La candidatura ya ha sido dado de alta.';
        RAISE E_ERROR;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
            NULL;
     END;

     -- Se inserta registro en la tabla
     INSERT INTO CANDIDATURA (ID_DEMARCACION, ID_PARTIDO, ESTADO)
       VALUES (pIddemarcacion, pIdpartido, 'PRESENTADA');
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE,'PK_ABM.ALTA_CANDIDATURA', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

  EXCEPTION
    WHEN E_ERROR THEN
      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PK_ABM.ALTA_CANDIDATURA', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PK_ABM.ALTA_CANDIDATURA', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

  END ALTA_CANDIDATURA;

  /******************************************************************************
   NOMBRE:      BAJA_CANDIDATURA
  ******************************************************************************/
  PROCEDURE BAJA_CANDIDATURA (
	pIddemarcacion IN CANDIDATURA.ID_DEMARCACION%TYPE,
	pIdpartido IN CANDIDATURA.ID_PARTIDO%TYPE,
	RSP OUT VARCHAR2) IS
   
   E_ERROR EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_DEMARCACION: '||pIddemarcacion||', ID_PARTIDO: '||pIdpartido;

     --Se verifica que alguno de los parametros tenga valor
     RSP := 'ERROR: El codigo de la demarcacion no puede ser nulo.';
     IF pIddemarcacion IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El codigo del partido politico no puede ser nulo.';
     IF pIdpartido IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que la persona exista en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM CANDIDATURA
        WHERE ID_DEMARCACION = pIddemarcacion
		  AND ID_PARTIDO = pIdpartido;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: La candidatura no existe.';
           RAISE E_ERROR;
     END;

     --Se actualiza el valor del estado a "ANULADA"
     BEGIN
     UPDATE CANDIDATURA 
		SET ESTADO = 'ANULADA' 
	 WHERE ID_DEMARCACION = pIddemarcacion 
		AND ID_PARTIDO = pIdpartido;
     EXCEPTION
       WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
     END;
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PK_ABM.BAJA_CANDIDATURA', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PK_ABM.BAJA_CANDIDATURA', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PK_ABM.BAJA_CANDIDATURA', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END BAJA_CANDIDATURA;
  
  /******************************************************************************
   NOMBRE:      MODIFICACION_CANDIDATURA
  ******************************************************************************/
  PROCEDURE MODIFICACION_CANDIDATURA (
	pIddemarcacion IN CANDIDATURA.ID_DEMARCACION%TYPE,
	pIdpartido IN CANDIDATURA.ID_PARTIDO%TYPE,
	pEstado IN CANDIDATURA.ESTADO%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_DEMARCACION: '||pIddemarcacion||', ID_PARTIDO: '||pIdpartido||', ESTADO: '||pEstado;

	 --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo de la demarcacion no puede ser nulo.';
     IF pIddemarcacion IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El codigo del partido politico no puede ser nulo.';
     IF pIdpartido IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El estado de la candidatura no puede ser nula.';
     IF pEstado IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El valor del estado de la candidatura es incorrecto. Valores correctos: PRESENTADA, APROBADA, RECHAZADA, ANULADA';
     IF pEstado NOT IN ('PRESENTADA','APROBADA','RECHAZADA','ANULADA')  THEN  RAISE E_ERROR; END IF;

     --Se verifica que la candidatura exista en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM CANDIDATURA
        WHERE ID_DEMARCACION = pIddemarcacion
		  AND ID_PARTIDO = pIdpartido;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: La candidatura no existe.';
           RAISE E_ERROR;
      END;

     --Si se pasan las pruebas de validacion actualiza
     BEGIN
	 UPDATE CANDIDATURA 
		SET ESTADO = pEstado 
     WHERE ID_DEMARCACION = pIddemarcacion
		AND ID_PARTIDO = pIdpartido;
 	 EXCEPTION
		WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
	 END;
	 RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PK_ABM.MODIFICACION_CANDIDATURA', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PK_ABM.MODIFICACION_CANDIDATURA', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PK_ABM.MODIFICACION_CANDIDATURA', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END MODIFICACION_CANDIDATURA;

  /******************************************************************************
   NOMBRE:      ALTA_CANDIDATO
   ******************************************************************************/
   PROCEDURE ALTA_CANDIDATO (
	pIdconvocatoria IN CANDIDATO.ID_CONVOCATORIA%TYPE,
	pIdpadron IN CANDIDATO.ID_PADRON%TYPE,
	pIddemarcacion IN CANDIDATO.ID_DEMARCACION%TYPE,
	pIdpartido IN CANDIDATO.ID_PARTIDO%TYPE,
	pOrden IN CANDIDATO.ORDEN%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_CONVOCATORIA: '||pIdconvocatoria||', ID_PADRON: '||pIdpadron||', ID_DEMARCACION: '||pIddemarcacion||', ID_PARTIDO: '||pIdpartido||', ORDEN: '||pOrden;
     
	 --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo de la convocatoria no puede ser nulo.';
     IF pIdconvocatoria IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El codigo del padron no puede ser nulo.';
     IF pIdpadron IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El codigo de la demarcacion no puede ser nulo.';
     IF pIddemarcacion IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El codigo del partido politico no puede ser nulo.';
     IF pIdpartido IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El orden en la candidatura no puede ser nulo.';
     IF pOrden IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que el registro no se haya insertado previamente
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM CANDIDATO
        WHERE ID_CONVOCATORIA = pIdconvocatoria
		  AND ID_PADRON = pIdpadron
		  AND ID_DEMARCACION = pIddemarcacion
		  AND ID_PARTIDO = pIdpartido
          AND ROWNUM  = 1;
        RSP := 'ERROR: El candidato ya ha sido dado de alta.';
        RAISE E_ERROR;
     EXCEPTION
       WHEN NO_DATA_FOUND THEN
            NULL;
     END;

     -- Se inserta registro en la tabla
     INSERT INTO CANDIDATO (ID_CONVOCATORIA, ID_PADRON, ID_DEMARCACION, ID_PARTIDO, ORDEN)
       VALUES (pIdconvocatoria, pIdpadron, pIddemarcacion, pIdpartido, pOrden);
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE,'PK_ABM.ALTA_CANDIDATO', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

  EXCEPTION
    WHEN E_ERROR THEN
      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PK_ABM.ALTA_CANDIDATO', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);
      RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
        VALUES(SYSDATE, 'PK_ABM.ALTA_CANDIDATO', PARAM_IN, 'RSP: '||RSP);
      COMMIT;

  END ALTA_CANDIDATO;

  /******************************************************************************
   NOMBRE:      BAJA_CANDIDATO
  ******************************************************************************/
  PROCEDURE BAJA_CANDIDATO (
	pIdconvocatoria IN CANDIDATO.ID_CONVOCATORIA%TYPE,
	pIdpadron IN CANDIDATO.ID_PADRON%TYPE,
	pIddemarcacion IN CANDIDATO.ID_DEMARCACION%TYPE,
	pIdpartido IN CANDIDATO.ID_PARTIDO%TYPE,
	RSP OUT VARCHAR2) IS
   
   E_ERROR EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_CONVOCATORIA: '||pIdconvocatoria||', ID_PADRON: '||pIdpadron||', ID_DEMARCACION: '||pIddemarcacion||', ID_PARTIDO: '||pIdpartido;

     --Se verifica que alguno de los parametros tenga valor
     RSP := 'ERROR: El codigo de la convocatoria no puede ser nulo.';
     IF pIdconvocatoria IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El codigo del padron no puede ser nulo.';
     IF pIdpadron IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El codigo de la demarcacion no puede ser nulo.';
     IF pIddemarcacion IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El codigo del partido politico no puede ser nulo.';
     IF pIdpartido IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que la persona exista en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM CANDIDATO
        WHERE ID_CONVOCATORIA = pIdconvocatoria
		  AND ID_PADRON = pIdpadron
		  AND ID_DEMARCACION = pIddemarcacion
		  AND ID_PARTIDO = pIdpartido;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: El candidato no existe.';
           RAISE E_ERROR;
     END;

     --Se elimina el candidato de la base de datos
     BEGIN
        DELETE CANDIDATO 
		WHERE ID_CONVOCATORIA = pIdconvocatoria 
			AND ID_PADRON = pIdpadron
			AND ID_DEMARCACION = pIddemarcacion
			AND ID_PARTIDO = pIdpartido;
     EXCEPTION
       WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
     END;
     RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PK_ABM.BAJA_CANDIDATO', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PK_ABM.BAJA_CANDIDATO', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PK_ABM.BAJA_CANDIDATO', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END BAJA_CANDIDATO;
  
 /******************************************************************************
   NOMBRE:      MODIFICACION_CANDIDATO
  ******************************************************************************/
  PROCEDURE MODIFICACION_CANDIDATO (
	pIdconvocatoria IN CANDIDATO.ID_CONVOCATORIA%TYPE,
	pIdpadron IN CANDIDATO.ID_PADRON%TYPE,
	pIddemarcacion IN CANDIDATO.ID_DEMARCACION%TYPE,
	pIdpartido IN CANDIDATO.ID_PARTIDO%TYPE,
	pOrden IN CANDIDATO.ORDEN%TYPE,
	RSP OUT VARCHAR2) IS

   E_ERROR       EXCEPTION;
   existe        VARCHAR2(1);
   PARAM_IN      VARCHAR2(200);
   err_num       NUMBER;
   err_msg       VARCHAR2(200);

   BEGIN
     PARAM_IN := 'ID_CONVOCATORIA: '||pIdconvocatoria||', ID_PADRON: '||pIdpadron||', ID_DEMARCACION: '||pIddemarcacion||', ID_PARTIDO: '||pIdpartido||', ORDEN: '||pOrden;
     
	 --Se verifica que todos los campos obligatorios tengan valor
     RSP := 'ERROR: El codigo de la convocatoria no puede ser nulo.';
     IF pIdconvocatoria IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El codigo del padron no puede ser nulo.';
     IF pIdpadron IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El codigo de la demarcacion no puede ser nulo.';
     IF pIddemarcacion IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El codigo del partido politico no puede ser nulo.';
     IF pIdpartido IS NULL THEN RAISE E_ERROR; END IF;

     RSP := 'ERROR: El orden en la candidatura no puede ser nulo.';
     IF pOrden IS NULL THEN RAISE E_ERROR; END IF;

     --Se verifica que el candidato exista en base de datos
     BEGIN
       SELECT 'S'
        INTO EXISTE
        FROM CANDIDATO
        WHERE ID_CONVOCATORIA = pIdconvocatoria
		  AND ID_PADRON = pIdpadron
		  AND ID_DEMARCACION = pIddemarcacion
		  AND ID_PARTIDO = pIdpartido;
     EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RSP := 'ERROR: El candidato no existe.';
           RAISE E_ERROR;
      END;

     --Si se pasan las pruebas de validacion actualiza
     BEGIN
	 UPDATE CANDIDATO 
		SET ORDEN = pOrden 
     WHERE ID_CONVOCATORIA = pIdconvocatoria
		AND ID_PADRON = pIdpadron
	    AND ID_DEMARCACION = pIddemarcacion
		AND ID_PARTIDO = pIdpartido;
 	 EXCEPTION
		WHEN OTHERS THEN
			RSP := SUBSTR(SQLERRM,1,200);
			RAISE E_ERROR;
	 END;
	 RSP := 'OK';

     INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
       VALUES(SYSDATE, 'PK_ABM.MODIFICACION_CANDIDATO', PARAM_IN, 'RSP: '||RSP);
     COMMIT;

   EXCEPTION
     WHEN E_ERROR THEN
       INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
         VALUES(SYSDATE, 'PK_ABM.MODIFICACION_CANDIDATO', PARAM_IN, 'RSP: '||RSP);
	   COMMIT;

     WHEN OTHERS THEN
	   err_num := SQLCODE;
       err_msg := SUBSTR(SQLERRM, 1, 200);
       RSP:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;

	   INSERT INTO LOG_PROCESOS (FECHA, PROCEDIMIENTO, PARAMETROS_ENTRADA, PARAMETROS_SALIDA)
		 VALUES(SYSDATE, 'PK_ABM.MODIFICACION_CANDIDATO', PARAM_IN, 'RSP: '||RSP);
       COMMIT;

  END MODIFICACION_CANDIDATO;

END PK_ABM;
